CREATE PROCEDURE [dbo].[sp_fajl_move] @oldPath varchar(150), @newPath varchar(150), @oldPathUserName varchar(20) = NULL, @oldPathPassword varchar(20) = NULL, @newPathUserName varchar(20) = NULL, @newPathPassword varchar(20) = NULL
AS
BEGIN

BEGIN TRY

	DECLARE @directory nvarchar(150), @mappaIndex int, @LotsOfText varchar(MAX), @result int = 1, @command nvarchar(500), @proxyAcc varchar(50) = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID),
		    @oldLogin varchar(100) = '', @newLogin varchar(100) = ''

	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END	

	--Felhasznlnv s jelsz bellts
	IF @oldPathUserName IS NOT NULL AND @oldPathPassword IS NOT NULL
	BEGIN
		SET @mappaIndex = CHARINDEX('\', REVERSE(@oldPath), 1)

		IF(@mappaIndex = 0)
		BEGIN
			SELECT -3 AS hiba, 'rvnytelen mappa' AS hibaszov
			RETURN
		END

		SET @oldLogin = 'NET USE ' + LEFT(@oldPath, LEN(@oldPath) - @mappaIndex) + ' /user:' + @oldPathUserName + ' ' + @oldPathPassword + '>nul && '
	END

	EXECUTE AS USER = @proxyAcc

	SET @command = @oldLogin + 'DIR "' + @oldPath +'" /B'
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	IF @result <> 0
		SELECT -2 AS hiba, 'Nincs meg a fjl: ' + @oldPath AS hibaszov
	ELSE
	BEGIN

		SET @mappaIndex = CHARINDEX('\', REVERSE(@newPath), 1)

		IF(@mappaIndex = 0)
		BEGIN
			REVERT
			SELECT -3 AS hiba, 'rvnytelen mappa' AS hibaszov
			RETURN
		END

		SET @directory = LEFT(@newPath, LEN(@newPath) - @mappaIndex)

		--Felhasznlnv s jelsz bellts
		IF @newPathUserName IS NOT NULL AND @newPathPassword IS NOT NULL
			SET @newLogin = 'NET USE ' + @directory + ' /user:' + @newPathUserName + ' ' + @newPathPassword + '>nul && '

		SET @command = @newLogin + 'DIR "' + @directory +'" /B'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT

		--ha mg nem ltezik a mappa
		IF @result <> 0
		BEGIN
			SET @mappaIndex = CHARINDEX('\', REVERSE(@directory), 1)

			IF(@mappaIndex = 0)
			BEGIN
				REVERT
				SELECT -3 AS hiba, 'rvnytelen mappa' AS hibaszov
				RETURN
			END

			SET @command = 'NET USE ' + LEFT(@directory, LEN(@directory) - @mappaIndex) + ' /user:' + @newPathUserName + ' ' + @newPathPassword + '>nul && MKDIR "' + @directory +'"'
			EXEC @result = xp_cmdshell @command, NO_OUTPUT

			--ha nem sikerlt ltrehozni
			IF @result <> 0
			BEGIN
				REVERT
				SELECT -4 AS hiba, 'Sikertelen mappa ltrehozs: ' + @directory AS hibaszov
				RETURN
			END

			--ellenrzs
			SET @command = @newLogin + 'DIR "' + @directory +'" /B'
			EXEC @result = xp_cmdshell @command, NO_OUTPUT

			--ha nem ltezik a mappa
			IF @result <> 0
			BEGIN
				REVERT
				SELECT -5 AS hiba, 'Nincs meg a mappa: ' + @directory AS hibaszov
				RETURN
			END
		END

		--nincs tesztelve ha a forrsnak s clnak is van jelszava
		SET @command = @oldLogin + @newLogin + 'MOVE "' + @oldPath + '" "' + @newPath + '"'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT
		
		IF @result <> 0
		BEGIN
			REVERT
			SELECT -6 AS hiba, 'Sikertelen tnevezs: ' + @oldPath + ' --> ' + @newPath AS hibaszov
			RETURN
		END
		
		SET @command = @newLogin + 'DIR "' + @newPath +'" /B'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT
		
		IF @result = 0
			SELECT 0 AS hiba, 'OK' AS hibaszov
		ELSE
			SELECT -7 AS hiba, 'Sikertelen trls (ellenrzs): ' + @newPath AS hibaszov
	END
	REVERT

END TRY
BEGIN CATCH
	REVERT
	SELECT -8 AS hiba, ERROR_MESSAGE() AS hibaszov
END CATCH

END