CREATE PROCEDURE [dbo].[sp_ftp_file_upload] @localPath varchar(150), @ftpPath varchar(150), @ftpUser varchar(50), @ftpPass varchar(50), @docSorID int = NULL, @szallitoID int = NULL
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @test char(1), @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50)

	/*IF DB_NAME() LIKE '%teszt%'
		RETURN*/

	SELECT TOP 1 @toolsPath = LTRIM(RTRIM(ToolsPath)), @proxyAcc = LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'WebShop\kri_ws.exe -operation:"ftpFileUpload" -ftpPath:"'+@ftpPath+'" -ftpUserName:"'+@ftpUser+'" -ftpUserPassword:"'+@ftpPass+'"' +
		(CASE WHEN @localPath IS NOT NULL THEN ' -localPath:"'+@localPath+'"' ELSE '' END) +
		(CASE WHEN @docSorID IS NOT NULL THEN ' -docSorID:'+CAST(@docSorID AS varchar) ELSE '' END) + 
		(CASE WHEN @szallitoID IS NOT NULL THEN ' -szallitoID:'+CAST(@szallitoID AS varchar) ELSE '' END) +
		(CASE WHEN @docSorID IS NOT NULL OR @szallitoID IS NOT NULL THEN ' -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'"' ELSE '' END)

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END
END