create PROCEDURE [dbo].[sp_iktat_egyen]  
	@iktid int
AS 
BEGIN
	SET NOCOUNT ON;
     declare @fizetett money,@dfizetett money,@hatralek money,@bizkelt date,@devizaid tinyint,@devizaert money,@tetelfejid int,@szallitoid int,@szszam varchar(20),@fszsz char(8)
     declare @naplob char(1),@konyvev tinyint,@jogcimid int,@naploid int,@szszid int,@eszszid int,@bizszov varchar(30),@tetelszam int,@uzemekid tinyint,@creuser smallint
    
  select @fizetett=sum( case
   when  e.afairany='S' and TKjel=0 then tartozik
   when sztukor.afairany='S' and TKjel=0 then -1*tartozik
   when  sztukor.afairany='S' and TKjel=1 then tartozik
   when   e.afairany='S' and TKjel=1 then -1*tartozik else 0
  end),
  @dfizetett=sum( case
   when  e.afairany='S' and TKjel=0 and naplofej.devizakod>1 then osszeg
   when sztukor.afairany='S' and TKjel=0 and naplofej.devizakod>1 then -1*osszeg
   when  sztukor.afairany='S' and TKjel=1 and naplofej.devizakod>1 then osszeg
   when   e.afairany='S' and TKjel=1 and naplofej.devizakod>1 then -1*osszeg else 0
  end),
   @bizkelt=max(bizkelt),@creuser=max(tetelfej.creuser)  from tetelsor               
 left join tetelfej on tetelfej.tetelfejID=tetelsor.tetelfejID
 left join naplofej on tetelfej.naploid=naplofej.naploid
 left join SZTUKOR on TETELSOR.SzszID=SZTUKOR.Sztukorid
 left join SZTUKOR e on TETELSOR.eSzszID=e.Sztukorid
 where  iktID=@iktID and tetelfej.naplotip<>'S' and (sztukor.afairany='S'  or e.afairany='S') 
  
    
     
  update iktat set fizetett=round(isnull(@fizetett,0),0) where @iktID=iktID
  select @hatralek=hatralek,@devizaid=devizaid,@devizaert=devizaert,@szallitoid=szallitoid,@szszam=szszam from iktat where @iktID=iktID
  if @devizaid>1
        update iktat set dfizetett=isnull(@dfizetett,0) where @iktID=iktID
  set @hatralek=isnull(@hatralek,0)
  if @hatralek=0
			 begin
		           update iktat set fizetve=@bizkelt where @iktID=iktID
 			   if @devizaid>1
                             update iktat set dfizetett=devizaert where @iktID=iktID
			 end
  else
		         update iktat set fizetve=null where @iktID=IktID	

  -- rfolyam klnbsg
  if @devizaid>1 and @hatralek<>0 and @devizaert=isnull(@dfizetett,0) and @devizaert<>0
    begin  
      select @konyvev=evekid from evek where year(@bizkelt)=ev
      set @naplob =rtrim(dbo.fc_setup('R',@konyvev,180)) 
      select @naploid=naploid from naplofej where  naplotip='X' AND bkod=@naplob and konyvev=@konyvev   
      select @fszsz=szsz,@uzemekid=tetelsor.uzemekid from tetelsor left join tetelfej on tetelsor.tetelfejid=tetelfej.tetelfejid left join sztukor on sztukor.sztukorid=tetelsor.szszid
        where iktid=@iktid and naplotip='S'
      select @szszid=sztukorid from sztukor where @konyvev=konyvev and szsz=@fszsz
      if @hatralek<0 
         begin
            SELECT @jogcimid=jogcimid,@eszszid=fszszid,@bizszov=szoveg  FROM jogcim WHERE jogcimKOD='RFVSZ' and konyvev=@konyvev  
	    set @tetelszam=@eszszid
            set @eszszid=@szszid
            set @szszid=@tetelszam   
            set @hatralek=abs(@hatralek)       
	 end
      else
         begin
            SELECT @jogcimid=jogcimid,@eszszid=elszszid,@bizszov=szoveg FROM jogcim WHERE jogcimKOD='RFNSZ' and konyvev=@konyvev
            
	end 
     set @tetelszam=1	
     if isnull(@jogcimid,0)=0 or isnull(@naploid,0)=0 or isnull(@szszid,0)=0 or isnull(@eszszid,0)=0
         return(-1)

create table #tmp_biz (arfolyam smallmoney null,analid int null,naturalia numeric(10,2) null,szemelyID smallint null,eszkozid smallint null,szallitoid smallint null,bbizszam varchar(10) null,
bizszam varchar(20) null,szkelt date null,tkelt date null,fizmodid tinyint null,fizhat date null,bizkelt date null,ekelt date null,brutto money null,jogcimid smallint null,bizszov varchar(50) null,
osszeg money,afaid tinyint,Afabev65 tinyint null,Szszid smallint,tartozik money,eszszid smallint,kovetel money,aszszid smallint null,szlahiv varchar(20),
naploid smallint,iktID int null,kvjel char(1) null,tetelsorid int null,cretime smalldatetime null,creuser smallint null,tetelfejID int null,sorszam smallint null,tetelszam int null,afaosszeg money null,
afa money null,netto money null,erkezett date null,stszovID int null,ktetelszam int null,stornojel char(1) null,sstornojel char(1) null,szamlaID int null,vevoid int null,kovetelid int null, peszov varchar(30), uzemekID int null)


--begin try
-- begin tran ARF
   insert into #tmp_biz 
	 (tetelfejID,tetelsorID,naploID,bizszam,bizkelt,ekelt,creuser,
	  jogcimID,szallitoID,bizszov,stszovId,kvjel,
	  osszeg,Afabev65,szlahiv,iktID,szszID,eszszID,aszszID,Tartozik,
	 kovetel,afaosszeg,szkelt,tkelt,fizmodID,fizhat,brutto,netto,afa,erkezett,sorszam,tetelszam,
	  ktetelszam,stornojel,sstornojel,SzamlaID,vevoID,arfolyam,analID,naturalia,szemelyID,eszkozID,peszov,uzemekid)
	 values
	 (  0,0,@naploID,'',@bizkelt,@bizkelt ,@CreUser ,
	  @jogcimID,@szallitoid ,@bizszov ,null ,'A' ,
	  @hatralek ,null ,@szszam ,@iktid ,@szszID ,
	  @eszszID ,null ,@hatralek ,@hatralek ,0 ,
	 null ,null ,1 ,@bizkelt ,null,null ,null, null,1,@tetelszam
	 ,null,null,null,null,null,1,null,null,null,null,null,@uzemekID)	

      create table #tmpx (t1 int,t2 varchar(100))
      insert #tmpx  exec [dbo].[sp_naplosrxs3_insert] @creuser
      select @tetelfejid=t1 from #tmpx
         update iktat set fizetett=brutto,fizetve=@bizkelt where @iktID=iktID
      insert #tmpx exec sp_konyvel @tetelfejid
    --  commit TRAN ARF
      return(1)
  -- end try 

 
  --  begin catch
  --     rollback tran ARF
  --     return -9 
  --  end catch	



    end --rfolyam nyer/veszt vge

end