CREATE PROCEDURE [dbo].[sp_kenyszerkezelt_szla_insert]
as
begin

/*#szfej*/
declare @szamlaID int, @vevoid int, @szkelt date, @fizhat date, @tkelt date, 
@fizmodid tinyint, @netto money, @brutto money, @creUser smallint, @tetszam int,
@tombID int, @konttet tinyint, @szlahiv char(10), @fizeto int, @tetelfejID int, 
@naploID int, @eloszov varchar(500), @utoszov varchar(500), @devizaid tinyint, @devizaert money, 
@arfolyam smallmoney, @neve varchar(50), @eszamlas bit, @veg char(1), @bankiD smallint, 
@beszedoID smallint, @arkategID tinyint, @tkelt1 date, @tkelt2 date, @szgcsopID tinyint, 
@szghelyid int, @egyenKelt date, @egyenleg money, @fizetendo money, @zona smallint, 
@riportosID smallint, @verzioSzam varchar(12),
 
/*#szsor*/
@szsorId int, @szlanevid int, @egysegar money, @mennyiseg numeric(10,3), @afaid int, 
@szolgID int, @tipus char(1), @afakulcs tinyint, @devizaar money, @Sztol date, 
@Szig date, @fohelyID int, @beszAr money, @egyeb varchar(200),
 
/*#kont*/
@szszID int, @eszszID int, @aszszID int, @osszeg money, @afaosszeg money, 
@bizszov varchar(50), @jogcimID int, @naturalia numeric(10,3), @uzemekID tinyint, /*@afaid int*/
 
/***TROLT ELJRS VLTOZI***/
/*szmlaszm kpzs*/
@szszam varchar(12), @tombsorsz int, @tombjel char(3), @tombkepzes char(1), @elonull tinyint,
@jogcimkod char(6), @Rjogcimkod char(6), @tombel char(1), @tombelk char(1),
 
/*NAPLOFEJ*/
@konyvev tinyint, @bbizszam char(12),
  
/*rgztsi naplid*/
@rgznaploid int, @rgzneve char(11), 
 
@devizafiz money,
 
/*TETELFEJ*/
@bizkelt date, @konyvmodx varchar(20),

/*szmlatmb v (szmlakeltbl)*/
@szkonyvEv tinyint
 
select @vevoid=vevoid, @szkelt=szkelt, @fizhat=fizhat, @tkelt=tkelt, @fizmodid=fizmodid, 
@netto=netto, @brutto=brutto, @creuser=creuser, @tetszam=tetszam, @tombid=tombid, 
@konttet=konttet, @szlahiv=szlahiv, @fizeto=fizeto, @tetelfejID=tetelfejID, @naploID=naploID, 
@Eloszov=Eloszov, @Utoszov=utoszov, @devizaid=devizaid, @devizaert=devizaert, @arfolyam=arfolyam, 
@neve=neve, @eszamlas=eszamlas, @veg=veg,@bankID=bankID, @beszedoID=beszedoID, 
@arkategID=arkategID, @tkelt1=tkelt1, @tkelt2=tkelt2, @szgcsopID=szgcsopID, @szghelyid=szghelyid, 
@egyenKelt=egyenKelt, @egyenleg=egyenleg, @fizetendo=fizetendo, @zona=zona, @riportosID=riportosID,
@verzioSzam=verzioSzam
from #szfej

set @netto=round(@netto*@arfolyam,0)
set @brutto=round(@brutto*@arfolyam,0)

if @arfolyam=1
  set @devizaert=null
  
begin try
	begin tran
 
	/*Meglv rgztsi napl*/
	if @tetelfejID=-1
	begin
		select @rgznaploid=max(rgzID) from RGZNAPLO where NaploID=@naploID and Zart='N'
		
		if isnull(@rgznaploid,0)=0
			select @tetelfejID=0 
		else
			select @rgzneve=rgzneve from RGZNAPLO where rgzid=@rgznaploID
	end
 
	/*j rgztsi napl*/
	if @tetelfejID=0
	begin
		update rgznaplo set zart='I' where NaploID=@naploID and Zart='N'
    
		select @rgzneve=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@szkelt),2)),2)+'-'+right('000'+ltrim(str(naplofej.RgzSorszam,3)),3)
		from naplofej
			left join evek on naplofej.KonyvEv=evek.evekID
		where naploID=@naploID

		insert into RGZNAPLO (NaploID,creUser,Neve,Zart,rgzneve)
			values (@naploID,@creUser,@neve,'N',@rgzneve)
			
		select @rgznaploid=SCOPE_IDENTITY()
	end

	if @brutto<>0
	begin
		update naplofej set sorszam=sorszam+1 where naploID=@naploID
		
		select @KonyvEv=naplofej.KonyvEv,
			@bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
		from naplofej
			left join evek on naplofej.KonyvEv=evek.evekID
		where naploID=@naploID 
  
		set @konyvmodx =rtrim(dbo.fc_setup('R',@konyvev,137))
		set @bizkelt=@tkelt  
  
		if @konyvmodx<>'Fiz.hatr'
			set @bizkelt=@szkelt
			
		insert into tetelfej (naploID,bizkelt,ekelt,bbizszam,bizszam,CreUser,tetelszam,KonyvEv,Naplotip,RgzID  ) 
			values(@naploID,@bizkelt,@bizkelt,@bbizszam,@szszam,@creUser,0,@KonyvEv,'V',@rgznaploid)
		
		select @tetelfejID=SCOPE_IDENTITY() 
	end
	else
	begin
		set @tetelfejID=-1
		
		select @KonyvEv=naplofej.KonyvEv,@bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
        from naplofej left join evek on naplofej.KonyvEv=evek.evekID
        where naploID=@naploID
	end

	SELECT @szkonyvEv=EvekID FROM EVEK WHERE LEFT(Ev,4)=STR(YEAR(@szkelt),4)

	UPDATE SZLATMBS SET TombSorsz=TombSorsz+1,Last_kelt=@szkelt WHERE TombID=@tombID AND TombEv=@szkonyvEV

	SELECT @tombsorsz=TombSorsz,@szszam=TombEvKep FROM SZLATMBS WHERE tombID=@tombID and TombEv=@szkonyvEV

	SELECT @tombjel=TombJel,@tombkepzes=TombKepzes,@elonull=Elonull,@jogcimkod=JogcimKod,@Rjogcimkod=Rjogcimkod,@tombel=Tombel,@tombelk=Tombelk FROM SZLATOMB WHERE TombID=@tombID

	IF @tombkepzes='B'
		SET @szszam=RTRIM(@tombjel)+RTRIM(@tombel)+RTRIM(@szszam)+RTRIM(@tombelk)+RIGHT('00000'+LTRIM(STR(@tombsorsz)),@elonull)
	IF @tombkepzes='S'
		SET @szszam=RIGHT('00000'+LTRIM(STR(@tombsorsz)),@elonull)+RTRIM(@tombel)+RTRIM(@tombjel)+RTRIM(@tombelk)+RTRIM(@szszam)
	IF @tombkepzes='N'
		SET @szszam=RIGHT('00000'+LTRIM(STR(@tombsorsz)),@elonull)+RTRIM(@tombel)+RTRIM(@szszam)+RTRIM(@tombelk)+RTRIM(@tombjel)
 
	if @devizaID<>1
		set @devizafiz=0
	else
		set @devizafiz=null
 
	insert into szamlak (vevoid,fizeto,szszam,szkelt,fizhat,tkelt,fizmodid,netto,brutto,bankID,beszedoID,creuser,TetelfejID,Eloszov,Utoszov,tombid,rgzID,arkategID,szlahiv,devizaid,devizaert,devizafiz,Fizetendo,EgyenKelt,Egyenleg,RiportosID,KeszPrgID,VerzioSzam,KulonAFA,SzlaStatus)
		values (@vevoid,@fizeto,@szszam,@szkelt,@fizhat,@tkelt,@fizmodid,@netto,@brutto,@bankID,@beszedoID,@creUser,@tetelfejID,@Eloszov,@Utoszov,@tombid,@rgznaploID,@arkategID,@szlahiv,@devizaid,@devizaert,@devizafiz,@fizetendo,@egyenKelt,@egyenleg,@riportosID,11,@verzioSzam,'L',(CASE WHEN @szlahiv IS NULL THEN 'N' ELSE 'H' END))

	set @szamlaID=SCOPE_IDENTITY()

	insert into szamlakv (szamlaid, tkelt1, tkelt2, szgcsopID, szghelyid,
						  veg, Zona)
				  values (@szamlaid, @tkelt1, @tkelt2, @szgcsopID, @szghelyid,
				          @veg, @zona)

	if @szlahiv IS NOT NULL
       update SZAMLAK set SzlaStatus='M' where szszam=@szlahiv

	update TETELFEJ set Bizszam=@szszam where TetelfejID=@tetelfejID

	set @szsorid=1 
	
	while @tetszam>=@szsorID
	begin
		select @egysegar=egysegar, @mennyiseg=mennyiseg, @afaid=afaid, 
			@szolgid=szolgid, @tipus=tipus, @afakulcs=afakulcs, @devizaar=devizaar, @Sztol=Sztol, 
			@Szig=Szig, @fohelyID=fohelyID, @beszAr=beszAr, @egyeb=egyeb
		from #szsor 
		where szsorID=@szsorID
   
		if @Sztol is null
		begin
			rollback tran
			select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nincs megadva Szmlzs kezdete (Sztol)!' as hibaszov,'' as szszam,0 as szamlaID
			return
		end
		if @Szig is null
		begin
		   rollback tran
		   select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nincs megadva Szmlzs vge (Szig)!' as hibaszov,'' as szszam,0 as szamlaID
		   return
		end

		insert into SZTETEL (SzamlaID,sznevekID,EgysegAr,mennyiseg,FohelyID,Afaid,afakulcs,tetelSorsz,tipus,devizaAr,Sztol,Szig,SzolgID,BeszAr,Egyeb)
			values (@szamlaID,@szlanevID,@egysegar,@mennyiseg,@fohelyID,@afaid,@afakulcs,@szsorID,@tipus,@devizaAr,@Sztol,@Szig,@szolgID,@beszAr,@egyeb)
		
		set @szsorid=@szsorid+1
	end
     
	if @tetelfejID<>-1
	begin	
		set @szsorID=1 
		
		while @konttet>=@szsorID
		begin
			/*TODO @Devizaban*/
			select @szszID=szszID,@eszszID=eszszID,@aszszID=aszszID,@osszeg=osszeg,@afaosszeg=afaosszeg,@bizszov=bizszov,@afaid=afaid,@jogcimID=jogcimID,@naturalia=naturalia,@uzemekID=uzemekID from #kont where kontID=@szsorID
			
			insert into tetelsor (tetelfejID,vevoid,szamlaid,SzszID,eszszID,aszszID,osszeg,tkjel,Tartozik,AfaOsszeg,kvjel,sorszam,Bizszov,afaid,fizmodid,jogcimID,szlahiv,Naturalia,UzemekID) 
				values (@tetelfejID,@fizeto,@szamlaid,@szszID,@eszszID,@aszszID,@osszeg+@afaosszeg,'True',@osszeg+@afaosszeg,@afaosszeg,'A',@szsorID,@bizszov,@afaid,@fizmodid,@jogcimID,@szlahiv,@naturalia,@uzemekID)
			
			set @szsorid=@szsorid+1
		end 
	end
	
	commit
    select @rgznaploid as rgznaplo,@rgzneve as nev,  0 as hiba,'OK' as hibaszov,@szszam as szszam,@szamlaID as szamlaID
  
end try 
begin catch
	rollback tran
	select 0 as rgznaplo,'' as nev,Error_number() as hiba,Error_message() as hibaszov,'' as szszam,0 as szamlaID
	return 
end catch
end