create PROCEDURE [dbo].[sp_naplosrb_select]
    @naploIDM int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
SET DEADLOCK_PRIORITY NORMAL; 
SELECT     dbo.TETELSOR.*, dbo.TETELFEJ.NaploID, dbo.TETELFEJ.Bbizszam, dbo.TETELFEJ.Bizkelt, dbo.TETELFEJ.Bizszam, dbo.TETELFEJ.Ekelt, 
                      dbo.TETELFEJ.CreUser, dbo.TETELFEJ.CreTime,dbo.tetelfej.stornojel,dbo.tetelfej.rgzID,
 dbo.IKTAT.Szszam, dbo.IKTAT.Szkelt, 
                      dbo.IKTAT.Tkelt, dbo.IKTAT.Fizhat, dbo.IKTAT.Brutto,iktat.netto, dbo.IKTAT.Erkezett, dbo.IKTAT.Afa,
                      dbo.tetelfej.tetelszam,tetelfej.konyvelve, 
                      dbo.iifcc2m(JOGCIM.Irany,'C',TETELSOR.Osszeg,0) as Csokken,
                      dbo.iifcc2m(JOGCIM.Irany,'N',TETELSOR.Osszeg,0) as Novekszik,                     
                      dbo.SZALLITO.Szkod, dbo.SZALLITO.Szneve,
                      dbo.vevo.vevokod,dbo.vevo.vevonev,
                      dbo.fizmodok.fizneve,dbo.fizmodok.fizkod,
					  dbo.jogcim.jogcimNev,dbo.jogcim.jogcimKod,JOGCIM.Irany,
					  dbo.asztukor.aszsz,dbo.asztukor.aneve,
					  dbo.sztukor.szszam as szsz,dbo.sztukor.neve,
					  dbo.esztukor.eszsz,dbo.esztukor.eneve,
                      dbo.vw_kont3p.tartozik,dbo.vw_kont3p.kovetel,dbo.vw_kont3p.afaosszeg,vw_kont3p.aszszID,vw_kont3p.eszszID,vw_kont3p.szszID,
					 dbo.AFAK.Afanev, dbo.AFAK.Szaz,
					 dbo.naplofej.naplonev,dbo.naplofej.naplotip,dbo.naplofej.bkod,
	dbo.rgznaplo.rgzneve
FROM         dbo.TETELSOR INNER JOIN
                      dbo.TETELFEJ ON dbo.TETELSOR.TetelfejID = dbo.TETELFEJ.TetelfejID
			 left JOIN dbo.IKTAT ON dbo.TETELsor.IktID = dbo.IKTAT.Iktid
            left JOIN dbo.afak ON dbo.tetelsor.afaID = dbo.afak.afaid                     
 left join dbo.szallito  ON dbo.szallito.szallitoID = dbo.TETELSOR.szallitoID
 LEFT join dbo.VEVO on dbo.VEVO.VevoID=dbo.TETELSOR.VevoID
            left JOIN dbo.fizmodok ON dbo.fizmodok.fizmodID = dbo.tetelsor.fizmodId
          left join dbo.jogcim ON dbo.TETELSOR.jogcimID = dbo.jogcim.jogcimID
		  left join  dbo.naplofej ON dbo.naplofej.naploid = dbo.TETELFEJ.naploID	
left join dbo.vw_kont3p on dbo.tetelsor.tetelsorID=vw_kont3p.tetelsorID  
left join dbo.sztukor on dbo.vw_kont3p.szszID=dbo.sztukor.sztukorID		
   left join dbo.esztukor on dbo.vw_kont3p.eszszID=dbo.esztukor.esztukorID		
left join dbo.asztukor on dbo.vw_kont3p.aszszID=dbo.asztukor.aszszID
left join dbo.rgznaplo on dbo.tetelfej.rgzid=dbo.rgznaplo.rgzid
where @naploIDM=tetelfej.naploID order by tetelsor.Tetelfejid




END
