CREATE PROCEDURE [dbo].[sp_online_szamla_kuld] @szamlaID int
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @test char(1), @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50)

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SET @proxyAcc = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	--2018.07.01 eltt teszt
	IF CAST(GETDATE() AS date) < '2018.07.01'
	BEGIN
		--Ha van ToolsPath s bejelentkezsi adatok
		SELECT @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG WHERE OtSzlaTnev IS NOT NULL AND OtSzlaPass IS NOT NULL AND OtSzlaKey IS NOT NULL AND OtSzlaCky IS NOT NULL

		IF @toolsPath IS NULL
			RETURN

		SET @test = 1
	END
	ELSE
	BEGIN
		--Ha van ToolsPath s bejelentkezsi adatok
		SELECT @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG WHERE OnSzlaTnev IS NOT NULL AND OnSzlaPass IS NOT NULL AND OnSzlaKey IS NOT NULL AND OnSzlaCky IS NOT NULL

		IF @toolsPath IS NULL
			RETURN

		SET @test = 0
	END

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'OnlineSzamla\kri_nav.exe -operation:"manageInvoice" -test:'+@test+' -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'" -invoiceID:'+CAST(@szamlaID as varchar)

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END
END