CREATE procedure [dbo].[sp_szamla_storno]
 @szamlaids int,@creuser smallint,@szamlazott char(1) =null ,@szamlazottID int =null
as
begin
declare @szkelt date,@fizhat date,@tkelt date,@fizeto int,@vevoid int,@fiznap tinyint,@fizmodid tinyint,@fiznapV tinyint,@nev varchar(50),@fizmodIDV tinyint,@tombID tinyint,@netto money,@brutto money,@afa money,@tetszam smallint
declare @tombjel char(3),@vnaplokod char(1),@konyvev tinyint,@naploid int,@szszID int, @eszszid int,@aszszid int,@jogcimid int,@bizszov varchar(50),@tetelfejid int,@szamlaid int
declare @nettoS money,@bruttoS money,@szlahiv varchar(12),@devizaID smallint,@VerzioSzam varchar(15),@kpVevonev varchar(8000)

-- sorokhoz
declare @pos bigint,@sortip char(1),@szolgID int,@cikkID int,@mennyi numeric (11,3),@egysegar money,@afaid tinyint,@afakulcs numeric (4,1),@egyeb varchar(200)
declare @eszsz varchar(8),@csereID int,@fszszid int,@fszszidS int,@devizaar money,@raktarID tinyint,@rendvsorID int,@arajsorid int,@bizsorid int,@uzemekid tinyint,@munkid int,@ktghelyid int,@kontid int,@konttet int

begin try
 begin tran
 select @tombid=tombID,@vevoid=vevoid,@fizeto=fizeto,@szlahiv=szszam,@fizmodid=FizmodID,@tkelt=tkelt,@szlahiv=szszam,@tombid=tombid,@nettoS=netto,@bruttoS=brutto,@devizaID=devizaid,@kpVevonev=KpVevonev from szamlak 
  where szamlaid=@szamlaids
   if @@rowcount=0 
   begin
    rollback
	select -1 as hiba,'Nincs ilyen szmla' as hibaszov
    return
   end

    select @konyvev=evekID from evek where year(getdate())=ev
  if @konyvev is null
   begin
     rollback
	select -6 as hiba,'Nincs v'as hibaszov
    return
   end
  
     select @vnaplokod=vnaplokod,@jogcimid=jogcimid,@bizszov=jogcim.szoveg from SZLATOMB left join JOGCIM on JOGCIM.JogcimKod=SZLATOMB.JogcimKod and KonyvEv=@konyvev
    where tombID=@tombID and tombtilt='N' and tombjel<>'*'
  if @@rowcount=0 
   begin
     select -1 as hiba,'nincs szmlatmb' as hibaszov
     return
   end


 
  select @naploid=naploid,@fszszid=fszsz from naplofej where naplotip='V' and bkod=@vnaplokod and konyvEv=@konyvEv
  if @naploid is null
    begin
      rollback
	 select -5 as hiba,'nincs napl' as hibaszov
     return
    end   
   set @szkelt=getdate()
   set @fizhat=getdate()


  create table #szsor (szsorid int,szolgid int,egysegar numeric(17,6),mennyiseg numeric (11,3),afaid int,tipus char(1),afakulcs tinyint,
    cikkid int,devizaar money,raktarid tinyint,rendvsorid int,arajsorid int,bizsorid int,kovetelid int,munkid int,ktghelyid int,egyeb varchar(500),fuvarjesID int)
  create table #kont (kontid int,szszID int,eszszID int,aszszID int,osszeg money,afaosszeg money,afaID int,bizszov varchar(50),jogcimid int,devizaban money,uzemekid int )
  create table #ktgfel (kontid int,munkID int,osszeg money,ktghelyid int )


  set @tetszam=0
  set @konttet=0
  set @nettoS=0
  set @bruttoS=0

  if CURSOR_STATUS('global','sztet')>=-1
   begin
	close sztet
       deallocate sztet
   end
  declare sztet cursor for
  select tipus,szolgid,CikkID,AfaID,Afakulcs,EgysegAr,mennyiseg,egyeb from SZTETEL where SzamlaID=@szamlaids
  open sztet
  fetch sztet into @sortip,@szolgID,@cikkID,@afaID,@afakulcs,@egysegar,@mennyi,@egyeb
  while @@Fetch_status=0
    begin
	  if @sortip='S'
		     select @fszszidS=esztukor.esztukorID,@eszsz=szolgal.bszsz,@eszszid=sztukorid,@aszszid=asztukor.asztukorid,@ktghelyid=ktghely.ktghelyid,@munkid=munkszam.munkid,@uzemekid=uzemek.uzemekid from szolgal
		      left join sztukor on sztukor.szsz=szolgal.bszsz and sztukor.konyvev=@konyvev 
		      left join asztukor on asztukor.aszsz=szolgal.aszsz and asztukor.konyvev=@konyvev 
                      left join esztukor on esztukor.eszsz=szolgal.vszsz and esztukor.konyvev=@konyvev 		     			
                      left join ktghely on ktghely.ktghkod=szolgal.ktghkod and ktghely.konyvev=@konyvev 
		      left join munkszam on munkszam.munkkod=szolgal.munkkod and munkszam.konyvev=@konyvev 
		      left join uzemek on uzemek.uzemekid=szolgal.uzemekid
		      where szolgID=@szolgID
		if @sortip='C'
	      select @eszszid=sztukorid,@eszsz=CIKKCSOP.arbszam,@aszszid=asztukor.asztukorid from cikk 
		     left join cikkcsop on cikk.cikkcsopid=cikkcsop.cikkcsopid
			   left join sztukor on sztukor.szsz=cikkcsop.arbszam and sztukor.konyvev=@konyvev 
			 left join afak on cikk.afaid=afak.afaid left join  asztukor on asztukor.aszsz=afak.fokszam and asztukor.konyvev=@konyvev 
             where cikkID=@cikkID
		
		 set @mennyi=@mennyi*-1
		 set @tetszam=@tetszam+1
         set @netto=round(@mennyi*@egysegar,0)
         set @afa=ROUND(@mennyi*@egysegar*@afakulcs/100,0)
         select @nettoS=@nettoS+@netto,@bruttoS=@bruttoS+@netto+@afa
         insert into #szsor (szsorid,szolgID,egysegar,mennyiseg,afaID,tipus,afakulcs,cikkID,devizaar,raktarID,rendvsorid,egyeb,fuvarjesID)
	          values (@tetszam,@szolgID,@egysegar,@mennyi,@afaID,@sortip,@afakulcs,@cikkID,@devizaar,@raktarID,@rendvsorid,@egyeb,null)		 
	
	
	
	 if not @fszszIDS  is null
       set @fszszID=@fszszidS
    set @szszID=@fszszID
    if left(@eszsz,1)='8' and @netto<0
	 begin
	   set  @csereid=@szszID
	   set @szszid=@eszszid
	   set @eszszid=@csereID
	   set @netto=ABS(@netto)
	   set @afa=ABS(@afa)
	 end
    select @kontid=kontid from #kont where szszID=@szszID and eszszID=@eszszid and afaID=@afaid and uzemekid=@uzemekid
    if @kontid is null
      begin
        set @konttet=@konttet+1
	insert into #kont (kontid,szszID, eszszID, aszszID, osszeg, afaosszeg, afaID, bizszov, jogcimid , devizaban,uzemekid)
	     values (@konttet,@szszID,@eszszid,@aszszid,@netto,@afa,@afaid,@bizszov,@jogcimID,@devizaar,@uzemekid)
      end
    else
      update #kont set osszeg=osszeg+@netto,afaosszeg=afaosszeg+@afa where kontid=@kontid


    if @munkid is not null or @ktghelyid is not null
	  begin
	     select @kontid=kontID from #ktgfel where @munkid=munkID and ktghelyid=@ktghelyid and kontid=@konttet
             if @kontid is null
		insert into #ktgfel values (@konttet,@munkid,@netto,@ktghelyid) 
             else
		update #ktgfel set osszeg=osszeg+@netto where kontid=@konttet
	  end
	
	  fetch sztet into @sortip,@szolgID,@cikkID,@afaID,@afakulcs,@egysegar,@mennyi,@egyeb
	end
	
   --- Fej szerkesztse
  create table #szfej (vevoid int,fizeto int,szkelt date,fizhat date,tkelt date,kdatum date,fizmodid tinyint,szlahiv char(12),netto money,brutto money,creuser smallint,tetszam int,tombID int,
    tetelfejID int,naploID smallint,konttet tinyint,neve varchar(50),eloSzov text,utoszov text,KpVevonev varchar(8000),Pnaplo char(1),Pnaplokod char(1),devizaid tinyint,devizaert money,arfolyam smallmoney,bankom tinyint,bankid smallint,kedvezmeny numeric(5,2),KeszPrgID tinyint,VerzioSzam varchar(15),KulonAFA char(1))

	select @verzioSzam=PrgVersion from programs where prgID=13
  insert into #szfej  (vevoid,fizeto,szkelt,fizhat,tkelt,kdatum,fizmodID,szlahiv,netto,brutto,creuser,tetszam,devizaID,arfolyam,tombID,naploid,tetelfejid,konttet,eloszov,KeszPrgID,VerzioSzam,KulonAFA,KpVevonev)
   values (@vevoid,@fizeto,@szkelt,@fizhat,@tkelt,@szkelt,@fizmodID,@szlahiv,@nettoS,@bruttoS,@creuser,@tetszam,@devizaID,1,@tombID,@naploID,-1,@konttet,'Hivatkozs:'+@szlahiv,13,@VerzioSzam,'N',@kpVevonev)


    create table #temp_szla (rgznaplo int,nev varchar(12),hiba int, hibaszov varchar(500),szszam varchar(12),szamlaid int,tetelfejid int)
  insert into #temp_szla exec sp_szla_insert
  select @tetelfejid=tetelfejid,@szamlaid=szamlaid from #temp_szla
  drop table #temp_szla
  if @tetelfejid>0  and @szamlaid>0
    begin
      create table #h2 (hiba int,hibaszov varchar(100))
      insert into #h2 exec sp_konyvel @tetelfejid
      drop table #h2
      if @szamlazott='O' and @szamlazottID is not null
		update OCSEREER set SzamlaID=null,szamlaszam='' where OcsereerID=@szamlazottID
      if @szamlazott='E' and @szamlazottID is not null
		update fogyhell set SzamlaID=null where FogyhellID=@szamlazottID
	  if @szamlazott='F' and @szamlazottID is not null
	  BEGIN
		UPDATE FUVARJEF SET Statusz='K' WHERE FuvarjefID=@szamlazottID
		UPDATE FUVARJES SET SztetelID = NULL WHERE SztetelID IN (SELECT SztetelID FROM SZTETEL WHERE SzamlaID = @szamlaids)
	  END
      commit
      select 0 as hiba,'OK' as hibaszov,@szamlaid as szamlaid
     end
   else
     begin
     	rollback tran
	    select -1 as hiba,'Nem jtt ltre a szmla' as hibaszov
     end 


 end try
  
 begin catch
   rollback tran
   select Error_number() as hiba,Error_message() as hibaszov
   return 
 end catch

end