CREATE procedure [dbo].[sp_tavho_szla_insert]
as
begin

/*#szfej*/
declare @szamlaID int, @vevoid int, @szkelt date, @fizhat date, @tkelt date, 
@fizmodid tinyint, @netto money, @brutto money, @creUser smallint, @tetszam int,
@tombID int, @konttet tinyint, @szlahiv char(12), @fizeto int,  @tetelfejID int, 
@naploID int, @eloszov varchar(500), @utoszov varchar(500), @devizaid tinyint, @devizaert money, 
@arfolyam smallmoney, @neve varchar(50), @eszamlas bit, @veg char(1), @bankiD smallint, 
@beszedoID smallint, @arkategID tinyint, @tkelt1 date, @tkelt2 date, @szgcsopID tinyint, 
@szghelyid int, @olvtet int, @tamogat smallmoney, @futAlapFt money, @futAlapLm3 numeric(10,3), 
@felmAlapFt money, @felmAlapLm3 numeric(10,3), @teljAlapFt money, @teljAlap numeric(10,3), @futes06Ft money, 
@futes06Gj numeric(10,3), @futes12Ft money, @futes12Gj numeric(10,3), @kgoFt money, @kgoGj numeric(10,3), 
@teljFt money, @teljGj numeric(10,3), @felmelegFt money, @felmelegm3 numeric(10,3), @vizFt money, 
@vizm3 int, @csatFt money, @csatm3 int, @egyenKelt date, @egyenleg money, 
@fizetendo money, @feltKamat money, @evesMegtak money, @haviMegtak money, @evesMegta2 money, 
@haviMegta2 money, @rezsiNelk money, @rezsiNelk2 money, @szlatmbsID smallint, @kpVevoNev varchar(MAX), 
@reszSorsz tinyint, @fejlecID tinyint, @eSzolgal char(1), @mellek4 bit, @verzioSzam varchar(12), @riportosID smallint,
 
/*#szsor*/
@szsorId int, @szlanevid int, @egysegar money, @mennyiseg numeric(10,3), @afaid int, 
@szolgID int, @tipus char(1), @afakulcs tinyint, @devizaar money, @Sztol date, 
@Szig date, @fohelyid int, @regiora varchar(6), @ujora varchar(6), @gj numeric(10,3), @egyeb varchar(200),
 
/*#kont*/
@szszID int, @eszszID int, @aszszID int, @osszeg money, @afaosszeg money, 
@bizszov varchar(50), @jogcimID int, @naturalia numeric(10,3), @uzemekID tinyint, /*@afaid int*/

/*#olv*/
@olvasID int, @olvID int, 
 
/***TROLT ELJRS VLTOZI***/
/*szmlaszm kpzs*/
@szszam varchar(12), @tombsorsz int, @tombjel char(3), @tombkepzes char(1),@elonull tinyint,
@jogcimkod char(6),@Rjogcimkod char(6),
 
/*NAPLOFEJ*/
@konyvev tinyint, @bbizszam char(12),
  
/*rgztsi naplid*/
@rgznaploid int, @rgzneve char(11), 
 
@devizafiz money,
 
/*TETELFEJ*/
@bizkelt date, @konyvmodx varchar(20)
 
select @vevoid=vevoid, @szkelt=szkelt, @fizhat=fizhat, @tkelt=tkelt, @fizmodid=fizmodid, 
@netto=netto, @brutto=brutto, @creuser=creuser, @tetszam=tetszam, @tombid=tombid, 
@konttet=konttet, @szlahiv=szlahiv, @fizeto=fizeto, @tetelfejID=tetelfejID, @naploID=naploID, 
@Eloszov=Eloszov, @Utoszov=utoszov, @devizaid=devizaid, @devizaert=devizaert, @arfolyam=arfolyam, 
@neve=neve, @eszamlas=eszamlas, @veg=veg,@bankID=bankID, @beszedoID=beszedoID, 
@arkategID=arkategID, @tkelt1=tkelt1, @tkelt2=tkelt2, @szgcsopID=szgcsopID, @szghelyid=szghelyid, 
@olvtet=olvtet, @tamogat=tamogat, @futAlapFt=futAlapFt, @futAlapLm3=futAlapLm3, @felmAlapFt=felmAlapFt, 
@felmAlapLm3=felmAlapLm3, @teljAlapFt=teljAlapFt, @teljAlap=teljAlap, @futes06Ft=futes06Ft, @futes06Gj=futes06Gj, 
@futes12Ft=futes12Ft, @futes12Gj=futes12Gj, @kgoFt=kgoFt, @kgoGj=kgoGj, @teljFt=teljFt, 
@teljGj=teljGj, @felmelegFt=felmelegFt, @felmelegm3=felmelegm3, @vizFt=vizFt, @vizm3=vizm3, 
@csatFt=csatFt, @csatm3=csatm3, @egyenKelt=egyenKelt, @egyenleg=egyenleg, @fizetendo=fizetendo, 
@feltKamat=feltKamat, @evesMegtak=evesMegtak, @haviMegtak=haviMegtak, @evesMegta2=evesMegta2, @haviMegta2=haviMegta2,
@rezsiNelk=rezsiNelk, @rezsiNelk2=rezsiNelk2, @szlatmbsID=szlatmbsID, @kpVevoNev=kpVevoNev, @reszSorsz=reszSorsz, 
@fejlecID=fejlecID, @eSzolgal=eSzolgal, @mellek4=mellek4, @verzioSzam=verzioSzam, @riportosID=riportosID
from #szfej

set @netto=round(@netto*@arfolyam,0)
set @brutto=round(@brutto*@arfolyam,0)

if @arfolyam=1
  set @devizaert=null
  
begin try
	begin tran
 
	/*Meglv tgztsi napl*/
	if @tetelfejID=-1
	begin
		select @rgznaploid=max(rgzID) from RGZNAPLO where NaploID=@naploID and Zart='N'
		
		if isnull(@rgznaploid,0)=0
			select @tetelfejID=0 
		else
			select @rgzneve=rgzneve from RGZNAPLO where rgzid=@rgznaploID
	end
 
	/*j rgztsi napl*/
	if @tetelfejID=0
	begin
		update rgznaplo set zart='I' where NaploID=@naploID and Zart='N'
    
		select @rgzneve=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00'+ltrim(str(month(@szkelt),2)),2)+'-'+right('000'+ltrim(str(naplofej.RgzSorszam,3)),3)
		from naplofej
			left join evek on naplofej.KonyvEv=evek.evekID
		where naploID=@naploID

		insert into RGZNAPLO (NaploID,creUser,Neve,Zart,rgzneve)
			values (@naploID,@creUser,@neve,'N',@rgzneve)
			
		select @rgznaploid=SCOPE_IDENTITY()
	end

	if @brutto<>0
	begin
		update naplofej set sorszam=sorszam+1 where naploID=@naploID
		
		select @KonyvEv=naplofej.KonyvEv,
			@bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
		from naplofej
			left join evek on naplofej.KonyvEv=evek.evekID
		where naploID=@naploID 
  
		set @konyvmodx =rtrim(dbo.fc_setup('R',@konyvev,137))
		set @bizkelt=@tkelt  
  
		if @konyvmodx<>'Fiz.hatr'
			set @bizkelt=@szkelt
			
		insert into tetelfej (naploID,bizkelt,ekelt,bbizszam,bizszam,CreUser,tetelszam,KonyvEv,Naplotip,RgzID  ) 
			values(@naploID,@bizkelt,@tkelt,@bbizszam,@szszam,@creUser,0,@KonyvEv,'V',@rgznaploid)
		
		select @tetelfejID=SCOPE_IDENTITY()
	end
	else
	begin
		set @tetelfejID=-1
		
		select @KonyvEv=naplofej.KonyvEv,@bbizszam=naplofej.naplotip+naplofej.bkod+right(rtrim(evek.Ev),2)+'-'+right('00000'+ltrim(str(sorszam,naplofej.bizhosz)),naplofej.bizhosz)
        from naplofej left join evek on naplofej.KonyvEv=evek.evekID
        where naploID=@naploID
	end

	update SZLATMBS set TombSorsz=TombSorsz+1,last_kelt=@szkelt where SzlatmbsID=@szlatmbsID

	select @tombsorsz=TombSorsz,@szszam=tombevKep from szlatmbs where SzlatmbsID=@szlatmbsID
	
	select @tombjel=tombjel,@tombkepzes=tombkepzes,@elonull=elonull,@jogcimkod=jogcimkod,@Rjogcimkod=Rjogcimkod 
	from SZLATOMB 
	where TombID=@tombID
	
	if @tombkepzes='S' 
		set @szszam=RTRIM(@tombjel)+rtrim(@szszam)+right('00000'+ltrim(STR(@tombsorsz)),@elonull)
	if @tombkepzes='N' 
		set @szszam=right('00000'+ltrim(STR(@tombsorsz)),@elonull)+'/'+rtrim(@szszam)+'/'+RTRIM(@tombjel)
	if @tombkepzes='B' 
		set @szszam=right('00000'+ltrim(STR(@tombsorsz)),@elonull)+'/'+rtrim(@szszam)+'/'+RTRIM(@tombjel)
 
	--select @jogcimID=jogcimID from jogcim where jogcimkod=@jogcimkod and KOnyvEv=@KonyvEv
	if @devizaID<>1
		set @devizafiz=0
	else
		set @devizafiz=null
 
	insert into szamlak (vevoid,fizeto,szszam,szkelt,fizhat,tkelt,fizmodid,netto,brutto,bankID,beszedoID,creuser,TetelfejID,Eloszov,Utoszov,tombid,rgzID,arkategID,szlahiv,devizaid,devizaert,devizafiz,EgyenKelt,Egyenleg,Fizetendo,FeltKamat,KpVevonev,FejlecID,Eszamlas,Eszolgal,SzlaStatus,KeszPrgID,VerzioSzam,KulonAFA,RiportosID)
		values (@vevoid,@fizeto,@szszam,@szkelt,@fizhat,@tkelt,@fizmodid,@netto,@brutto,@bankID,@beszedoID,@creUser,@tetelfejID,@Eloszov,@Utoszov,@tombid,@rgznaploID,@arkategID,@szlahiv,@devizaid,@devizaert,@devizafiz,@egyenKelt,@egyenleg,@fizetendo,@feltKamat,@kpVevoNev,@fejlecID,@eszamlas,@eSzolgal,'N',10,@verzioSzam,'L',@riportosID)

	set @szamlaID=SCOPE_IDENTITY()

	insert into szamlakv (szamlaid, tkelt1, tkelt2, szgcsopID, szghelyid,
						  veg, tamogat, CAlapdij, FutAlapLm3, FelmAlapFt,
						  FelmAlapLm, TeljAlapFt, TeljAlap, Futes06Ft, Futes06Gj, 
						  Futes12Ft, Futes12Gj, Egyeb, Gj, TeljFt, 
						  TeljGj, KvDij, Felmelegm3, VizFt, Vizm3, 
						  CsatFt, CsatM3, EvesMegtak, HaviMegtak, EvesMegta2, 
						  HaviMegta2, RezsiNelk, RezsiNelk2, ReszSorsz, Mellek4)
				  values (@szamlaid, @tkelt1, @tkelt2, @szgcsopID, @szghelyid,
				          @veg, @tamogat, @futAlapFt, @futAlapLm3, @felmAlapFt,
				          @felmAlapLm3, @teljAlapFt, @teljAlap, @futes06Ft, @futes06Gj, 
				          @futes12Ft, @futes12Gj, @kgoFt, @kgoGj, @teljFt, 
				          @teljGj, @felmelegFt, @felmelegm3, @vizFt, @vizm3, 
				          @csatFt, @csatm3, @evesMegtak, @haviMegtak, @evesMegta2, 
				          @haviMegta2, @rezsiNelk, @rezsiNelk2, @reszSorsz, @mellek4)

	update TETELFEJ set Bizszam=@szszam where TetelfejID=@tetelfejID

	set @szsorid=1 
	
	while @tetszam>=@szsorID
	begin
		select @szlanevid=szlanevid, @egysegar=egysegar, @mennyiseg=mennyiseg, @afaid=afaid, 
			@szolgid=szolgid, @tipus=tipus, @afakulcs=afakulcs, @devizaar=devizaar, @Sztol=Sztol, 
			@Szig=Szig, @fohelyid=FohelyID, @regiora=regiora,@ujora=ujora, @gj=gj, @egyeb=egyeb
		from #szsor 
		where szsorID=@szsorID
   
		/*TVH*/
		if @fohelyid is null or @fohelyid=0
		begin
			rollback tran
			select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nincs megadva fogyasztsi hely (FohelyID)!' as hibaszov,'' as szszam,0 as szamlaID
			return
		end
		if @Sztol is null
		begin
			rollback tran
			select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nincs megadva Szmlzs kezdete (Sztol)!' as hibaszov,'' as szszam,0 as szamlaID
			return
		end
		if @Szig is null
		begin
		   rollback tran
		   select 0 as rgznaplo,'' as nev,Error_number() as hiba,'Nincs megadva Szmlzs vge (Szig)!' as hibaszov,'' as szszam,0 as szamlaID
		   return
		end

		insert into SZTETEL (SzamlaID,sznevekID,EgysegAr,mennyiseg,fohelyid,RegiOra,ujora,Afaid,afakulcs,tetelSorsz,tipus,devizaAr,Sztol,Szig,SzolgID,m3,Egyeb)
			values (@szamlaID,@szlanevID,@egysegar,@mennyiseg,@fohelyid,@regiora,@ujora,@afaid,@afakulcs,@szsorID,@tipus,@devizaAr,@Sztol,@Szig,@szolgID,@gj,@egyeb)
		
		set @szsorid=@szsorid+1
	end
     
	if @tetelfejID<>-1
	begin	
		set @szsorID=1 
		
		while @konttet>=@szsorID
		begin
			/*TODO @Devizaban*/
			select @szszID=szszID,@eszszID=eszszID,@aszszID=aszszID,@osszeg=osszeg,@afaosszeg=afaosszeg,@bizszov=bizszov,@afaid=afaid,@jogcimID=jogcimID,@naturalia=naturalia,@uzemekID=uzemekID from #kont where kontID=@szsorID
			
			insert into tetelsor (tetelfejID,vevoid,szamlaid,SzszID,eszszID,aszszID,osszeg,tkjel,Tartozik,AfaOsszeg,kvjel,sorszam,Bizszov,afaid,fizmodid,jogcimID,szlahiv,Naturalia,UzemekID) 
				values (@tetelfejID,@fizeto,@szamlaid,@szszID,@eszszID,@aszszID,@osszeg+@afaosszeg,'True',@osszeg+@afaosszeg,@afaosszeg,'A',@szsorID,@bizszov,@afaid,@fizmodid,@jogcimID,@szlahiv,@naturalia,@uzemekID)
			
			set @szsorid=@szsorid+1
		end 
	end

	set @olvID=1
	
	while @olvtet>=@olvID
	begin
		select @olvasID=olvasid from #olv where olvid=@olvID
		
		set @olvID=@olvID+1
		
		update OLVAS set szamlaID=@szamlaID where OlvasID=@olvasID
	end
	
	commit
    select @rgznaploid as rgznaplo,@rgzneve as nev,  0 as hiba,'OK' as hibaszov,@szszam as szszam,@szamlaID as szamlaID
  
end try 
begin catch
	rollback tran
	select 0 as rgznaplo,'' as nev,Error_number() as hiba,Error_message() as hibaszov,'' as szszam,0 as szamlaID
	return 
end catch
end