CREATE TRIGGER [dbo].[tr_akcio_modify3] ON [dbo].[AKCIO] FOR UPDATE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('FLEX')) = 0
	RETURN

DECLARE @cikkID int, @akcioID smallint, @tol date, @ig date, @webErvenyes bit,

		@dTol date, @dIg date, @dWebErvenyes bit, @gcmMuvInt int, @webre bit, @webre2 bit

SELECT @akcioID=AkcioID, @tol=Tol, @ig=Ig, @webErvenyes=(CASE WHEN Ervenyes IN('M','W') THEN 1 ELSE 0 END) FROM inserted

SELECT @dTol=Tol, @dIg=Ig, @dWebErvenyes=(CASE WHEN Ervenyes IN('M','W') THEN 1 ELSE 0 END) FROM deleted

--Ha nem vltozott az tadott rtkek valamelyike
IF @tol = @dTol AND @ig = @dIg AND @webErvenyes = @dWebErvenyes
	RETURN

--Akci tl-ig most nem mai napi, de eddig sem volt vagy nem volt web rvnyes s most se az
IF (CAST(GETDATE() AS DATE) NOT BETWEEN @tol AND @ig AND CAST(GETDATE() AS DATE) NOT BETWEEN @dTol AND @dIg) OR 
   (@webErvenyes = 0 AND @dWebErvenyes = 0)
	RETURN

DECLARE CikkAkcioCursor CURSOR FOR

	SELECT CIKK.CikkID, ISNULL(CIKK.Webre,0), ISNULL(CIKK.Webre2,0)
	FROM CIKKAKC
		 INNER JOIN CIKK ON CIKK.CikkID = CIKKAKC.CikkID
	WHERE CIKKAKC.AkcioID = @akcioID AND ISNULL(CIKK.Megszunt,0) = 0 AND CIKK.Cikkhiercs IS NOT NULL AND (CIKK.Webre = 1 OR CIKK.Webre2 = 1)

OPEN CikkAkcioCursor

FETCH NEXT FROM CikkAkcioCursor INTO @cikkID, @webre, @webre2

WHILE @@FETCH_STATUS = 0
BEGIN

	IF @webUserID <> '' AND @webre = 1
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID)
	
	IF @webUserID2 <> '' AND @webre2 = 1
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID2)

	FETCH NEXT FROM CikkAkcioCursor INTO @cikkID, @webre, @webre2
END

CLOSE CikkAkcioCursor
DEALLOCATE CikkAkcioCursor