CREATE TRIGGER [dbo].[tr_arlists_modify] ON [dbo].[ARLISTS] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') = 0
	RETURN

DECLARE @arlistsID int, @cikkID int, @egysegAr money, @ervenyes date, @megszunt bit, @cikkhiercs smallint, @webre bit, @webre2 bit,

		@dArlistsID int, @dCikkID int, @dEgysegAr money, @dErvenyes date, @dMegszunt bit, @dCikkhiercs smallint, @dWebre bit, @dWebre2 bit,

		@gcmMuvInt int

SELECT @arlistsID=inserted.ArlistsID, @cikkID=inserted.CikkID, @egysegAr=inserted.EgysegAr, @ervenyes=inserted.Ervenyes,
	   @megszunt=ISNULL(CIKK.Megszunt,0), @cikkhiercs=CIKK.Cikkhiercs, @webre=ISNULL(CIKK.Webre,0), @webre2=ISNULL(CIKK.Webre2,0)
FROM inserted
	 INNER JOIN CIKK ON CIKK.CikkID = inserted.CikkID

SELECT @dArlistsID=deleted.ArlistsID, @dCikkID=deleted.CikkID, @dEgysegAr=deleted.EgysegAr, @dErvenyes=deleted.Ervenyes,
	   @dMegszunt=ISNULL(CIKK.Megszunt,0), @dCikkhiercs=CIKK.Cikkhiercs, @dWebre=ISNULL(CIKK.Webre,0), @dWebre2=ISNULL(CIKK.Webre2,0)
FROM deleted
	 INNER JOIN CIKK ON CIKK.CikkID = deleted.CikkID

--Trls vagy (mdosts s (megsznt, nincs hierarchia vagy nem webre))
IF (@arlistsID IS NULL AND @dArlistsID IS NOT NULL) OR (@arlistsID IS NOT NULL AND @dArlistsID IS NOT NULL AND ((@dMegszunt = 0 AND @megszunt = 1) OR (@dCikkhiercs IS NOT NULL AND @cikkhiercs IS NULL) OR (@dWebre = 1 AND @webre = 0) OR (@dWebre2 = 1 AND @webre2 = 0)))
BEGIN
	--Megsznt, hierarchia nlkli vagy nem Webshop trlst nem kell kikldeni
	IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR (@dWebre = 0 AND @dWebre2 = 0)
		RETURN

	SET @gcmMuvInt = 104 --rlista cikk trls
	SET @arlistsID = @dArlistsID
	SET @webre = @dWebre
	SET @webre2 = @dWebre2

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webre = 1 AND @webUserID <> '' 
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @arlistsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 103) AND UserID = @webUserID

	IF @webre2 = 1 AND @webUserID2 <> '' 
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @arlistsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 103) AND UserID = @webUserID2
END
--j vagy mdosts
ELSE
BEGIN

	IF @megszunt = 1 OR @cikkhiercs IS NULL OR (@webre = 0 AND @webre2 = 0)
		RETURN

	SET @gcmMuvInt = 103 --rlista cikk letlts

	--Mdosts
	IF @dArlistsID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @egysegAr = @dEgysegAr AND ISNULL(@ervenyes,'1900.01.01') = ISNULL(@dErvenyes,'1900.01.01')
			RETURN
	END

	-- Letlts esetn zrtt tenni a korbbi rekordhoz tartoz trls esemnyeket
	IF @webre = 1 AND @webUserID <> '' 
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @arlistsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 104) AND UserID = @webUserID

	IF @webre2 = 1 AND @webUserID2 <> '' 
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @arlistsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 104) AND UserID = @webUserID2
END

IF @webre = 1 AND @webUserID <> '' 
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@arlistsID,@webUserID)

IF @webre2 = 1 AND @webUserID2 <> '' 
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@arlistsID,@webUserID2)