CREATE TRIGGER [dbo].[tr_cikkacsh_modify] ON [dbo].[CIKKACSH] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkAcshID int, @cikkConsID int, @cikkAcstID smallint, @sorrend smallint,

		@dCikkAcshID int, @dCikkConsID int, @dCikkAcstID smallint, @dSorrend smallint,

		@gcmMuvInt int

SELECT @cikkAcshID=CikkAcshID, @cikkConsID=CikkconsID, @cikkAcstID=CikkAcstID, @sorrend=Sorrend FROM inserted

SELECT @dCikkAcshID=CikkAcshID, @dCikkConsID=CikkconsID, @dCikkAcstID=CikkAcstID, @dSorrend=Sorrend FROM deleted

--j vagy mdosts
IF @cikkAcshID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 82 --ltalnos cikkcsoport tpus lers letlts

	--Mdosts
	IF @dCikkAcshID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkConsID = @dCikkConsID AND @cikkAcstID = @dCikkAcstID AND @sorrend = @dSorrend
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 83 --ltalnos cikkcsoport tpus lers trls
	SET @cikkAcshID = @dCikkAcshID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAcshID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 82) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkAcshID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 82) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAcshID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkAcshID,@webUserID2)