CREATE TRIGGER [dbo].[tr_cikkakc_modify4] ON [dbo].[CIKKAKC] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID2 smallint

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('FLEX')) = 0
	RETURN

DECLARE @cikkAkcID int, @akcioID smallint, @cikkID int, @egysarArB money, @megszunt bit, @cikkhiercs smallint, @webre2 bit,

		@dCikkAkcID int, @dAkcioID smallint, @dCikkID int, @dEgysarArB money, @dMegszunt bit, @dCikkhiercs smallint, @dWebre2 bit

SELECT @cikkAkcID=inserted.CikkAkcID, @akcioID=inserted.AkcioID, @cikkID=CIKK.CikkID, @egysarArB=inserted.EgysarArb,
	   @megszunt=ISNULL(CIKK.Megszunt,0), @cikkhiercs=CIKK.Cikkhiercs, @webre2=ISNULL(CIKK.Webre2,0)
FROM inserted
	 INNER JOIN CIKK ON CIKK.CikkID = inserted.CikkID

SELECT @dCikkAkcID=deleted.CikkAkcID, @dAkcioID=deleted.AkcioID, @dCikkID=CIKK.CikkID, @dEgysarArB=deleted.EgysarArb,
	   @dMegszunt=ISNULL(CIKK.Megszunt,0), @dCikkhiercs=CIKK.Cikkhiercs, @dWebre2=ISNULL(CIKK.Webre2,0)
FROM deleted
	 INNER JOIN CIKK ON CIKK.CikkID = deleted.CikkID

--j vagy mdosts
IF @cikkAkcID IS NOT NULL
BEGIN
	--Nem aktulis akci
	IF (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @akcioID AND CAST(GETDATE() AS DATE) BETWEEN Tol AND Ig AND Ervenyes IN('M','W')) = 0
		RETURN

	--Mdosts
	IF @dCikkAkcID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @egysarArB = @dEgysarArB
			RETURN

		--ha megvltozott a cikk, az eredeti cikk jboli letltse
		IF @cikkID <> @dCikkID
		BEGIN
			IF @dMegszunt = 0 AND @dCikkhiercs IS NOT NULL AND @dWebre2 = 1
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@dCikkID,@webUserID2)
		END
	END

	IF @megszunt = 1 OR @cikkhiercs IS NULL OR @webre2 = 0
		RETURN
END
ELSE
BEGIN
	--Nem aktulis akci
	IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR @dWebre2 = 0 OR (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @dAkcioID AND CAST(GETDATE() AS DATE) BETWEEN Tol AND Ig AND Ervenyes IN('M','W')) = 0
		RETURN

	SET @cikkID = @dCikkID
END

INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID2)