CREATE TRIGGER [dbo].[tr_cikkconh_modify] ON [dbo].[CIKKCONH] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkConhID int, @cikkConsID int, @cikkHierID int, @sorrend smallint,

		@dCikkConhID int, @dCikkConsID int, @dCikkHierID int, @dSorrend smallint,

		@gcmMuvInt int

SELECT @cikkConhID=CikkconhID, @cikkConsID=CikkconsID, @cikkHierID=CikkHierID, @sorrend=Sorrend FROM inserted

SELECT @dCikkConhID=CikkconhID, @dCikkConsID=CikkconsID, @dCikkHierID=CikkHierID, @dSorrend=Sorrend FROM deleted

--j vagy mdosts
IF @cikkConhID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 46 --Cikk hierearchia lers letlts

	--Mdosts
	IF @dCikkConhID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkConsID = @dCikkConsID AND @cikkHierID = @dCikkHierID AND @sorrend = @dSorrend
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 47 --Cikk hierearchia lers trls
	SET @cikkConhID = @dCikkConhID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkConhID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 46) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkConhID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 46) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkConhID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkConhID,@webUserID2)