CREATE TRIGGER [dbo].[tr_cikkconx_modify] ON [dbo].[CIKKCONX] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkConxID int, @ertek varchar(500),

		@dCikkConxID int, @dErtek varchar(500),

		@gcmMuvInt int

SELECT @cikkConxID=CikkconxID, @ertek=Ertek FROM inserted

SELECT @dCikkConxID=CikkconxID, @dErtek=Ertek FROM deleted

--j vagy mdosts
IF @cikkConxID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 48 --Cikk lers rtk letlts

	--Mdosts
	IF @dCikkConxID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @ertek = @dErtek
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 49 --Cikk lers rtk trls
	SET @cikkConxID = @dCikkConxID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkConxID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 48) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkConxID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 48) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkConxID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkConxID,@webUserID2)