CREATE TRIGGER [dbo].[tr_csomkuld_insert] ON [dbo].[CSOMKULD] 
FOR INSERT
AS

DECLARE @rendvfejID int, @creUser smallint, @szamlaID int, @bizfejID int, @webUserID smallint, @webUserID2 smallint, @gcmMuvID int

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('FLEX')) = 0
	RETURN

SELECT @szamlaID = SzamlaID, @bizfejID = BizfejID FROM inserted

SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 100

DECLARE RendelesCursor CURSOR FOR

SELECT DISTINCT RENDVSOR.RendvfejID, RENDVFEJ.CreUser
FROM RENDVSOR
     INNER JOIN RENDVFEJ ON RENDVFEJ.RendvfejID = RENDVSOR.RendvfejID
	 INNER JOIN VEVO ON VEVO.VevoID = RENDVFEJ.VevoID
	 LEFT JOIN SZTETEL ON SZTETEL.SztetelID = RENDVSOR.SztetelID
     LEFT JOIN BIZSOR ON BIZSOR.BizsorID = RENDVSOR.BizSorID
WHERE RENDVFEJ.CreUser IN(@webUserID,@webUserID2) AND (SZTETEL.SzamlaID = @szamlaID OR BIZSOR.BizfejID = @bizfejID)

OPEN RendelesCursor

FETCH NEXT FROM RendelesCursor INTO @rendvfejID, @creUser

WHILE @@FETCH_STATUS = 0
BEGIN
	IF @webUserID <> '' AND @webUserID = @creUser
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID,@rendvfejID,@webUserID)
	ELSE IF @webUserID2 <> '' AND @webUserID2 = @creUser
		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES (@gcmMuvID,@rendvfejID,@webUserID2)

	FETCH NEXT FROM RendelesCursor INTO @rendvfejID, @creUser
END

CLOSE RendelesCursor
DEALLOCATE RendelesCursor