CREATE TRIGGER [dbo].[tr_deviza_modify] ON [dbo].[DEVIZA] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @devizaID tinyint, @devizaJel char(3),

		@dDevizaID tinyint, @dDevizaJel char(3),

		@gcmMuvInt int

SELECT @devizaID=DevizaID, @devizaJel=DevizaJel FROM inserted

SELECT @dDevizaID=DevizaID, @dDevizaJel=DevizaJel FROM deleted

--j vagy mdosts
IF @devizaID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 68 --Deviza letlts

	--Mdosts
	IF @dDevizaID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @devizaJel = @dDevizaJel
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 69 --Deviza trls
	SET @devizaID = @dDevizaID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @devizaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 68) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @devizaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 68) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@devizaID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@devizaID,@webUserID2)