CREATE TRIGGER [dbo].[tr_fogyhels_insert] ON [dbo].[FOGYHELS]
FOR INSERT, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE 
	@fogyhelsID int, @fogyhellID int,
	@dFogyhelsID int, @dFogyhellID int, @dSzemelyID smallint,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @fogyhelsID = FogyhelsID, @fogyhellID = fogyhellID FROM inserted
	SELECT @dFogyhelsID = FogyhelsID, @dFogyhellID = fogyhellID FROM deleted

	--Ha mr zrt
	IF (SELECT COUNT(*) FROM FOGYHELL WHERE FogyHEllID = ISNULL(@fogyhellID, @dFogyhellID) AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
	BEGIN
		RETURN
	END

	BEGIN TRAN

	IF @fogyhelsID IS NOT NULL
	BEGIN
		IF @dFogyhelsID IS NULL
			SET @gcmMuvInt = 14 -- j ellenrzs munka
	END
	ELSE
	BEGIN
		SET @fogyhelsID = @dFogyhelsID
		SET @fogyhellID = @dFogyhellID

		SET @gcmMuvInt = 15 -- Ellenrzs munka trls

		-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @fogyhelsID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (14))
	END

	SELECT @userID = USERS.UserID
	FROM FOGYHELL
         LEFT JOIN SZHELLEN ON SZHELLEN.SZHELLENID =  FOGYHELL.EllSzem
         LEFT JOIN USERS ON USERS.SzemelyID = SZHELLEN.szemelyID
	WHERE FOGYHELL.FogyHEllID = @fogyhellID AND FOGYHELL.Lezarva IS NULL AND USERS.SyncInterv IS NOT NULL

	--Ha nincs felhasznlhoz ktve
	IF @userID IS NULL
	BEGIN
		COMMIT
		RETURN
	END

	SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, FogyHEllID) VALUES (@gcmMuvID, @fogyhelsID, @userID, @fogyhellID)

	COMMIT

END TRY
BEGIN CATCH
	ROLLBACK
END CATCH
END