CREATE TRIGGER [dbo].[tr_koztertp_modify] ON [dbo].[KOZTERTP] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @koztertpID smallint, @koztertpNv varchar(15),

		@dKoztertpID smallint, @dKoztertpNv varchar(15),

		@gcmMuvInt int

SELECT @koztertpID=KoztertpID, @koztertpNv=KoztertpNv FROM inserted

SELECT @dKoztertpID=KoztertpID, @dKoztertpNv=KoztertpNv FROM deleted

--j vagy mdosts
IF @koztertpID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 74 --Kzterlet letlts

	--Mdosts
	IF @dKoztertpID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @koztertpNv = @dKoztertpNv
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 75 --Kzterlet trls
	SET @koztertpID = @dKoztertpID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @koztertpID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 74) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @koztertpID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 74) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@koztertpID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@koztertpID,@webUserID2)