CREATE TRIGGER [dbo].[tr_levelek_update] ON [dbo].[LEVELEK] 
FOR UPDATE
AS
DECLARE @postazva date, @postazvad date, @levelekid int, @irany char(1), @kelt date, @hivatkozas int, @statusz char(1), @belsoLev bit, @belsoLevd bit

SELECT @postazva=Postazva, @levelekid=LevelekID, @irany=Irany, @kelt=Kelt, @hivatkozas=Hivatkozas, @belsoLev=BelsoLev, @statusz=Statusz FROM inserted
SELECT @postazvad=Postazva, @belsoLevd=BelsoLev FROM deleted

IF @irany = 'K'
BEGIN
	--Postzs dtumt megadja vagy alrs utn bels levelezsre lltjk
	IF (ISNULL(@postazvad,'1900.01.01') = '1900.01.01' AND ISNULL(@postazva,'1900.01.01') > '1900.01.01') OR
	   (@statusz = 'P' AND ISNULL(@belsoLevd, 0) = 0 AND ISNULL(@belsoLev, 0) = 1)
	BEGIN
		UPDATE LEVELEK SET Statusz = 'E' WHERE LevelekID = @levelekID

		IF ISNULL(@hivatkozas,0) > 0
		  UPDATE LEVELEK SET Statusz = 'M', Postazva = @postazva WHERE LevelekID = @hivatkozas or kovetkezo=@levelekID
	END
END