CREATE TRIGGER [dbo].[tr_munklap_modify] ON [dbo].[MUNKLAP] 
FOR INSERT, UPDATE, DELETE
AS

IF DB_NAME() <> 'kri_ktrt'
	RETURN

DECLARE @munkalapID int, @mlapatvesz smallint, @jarmuID int,
		@dMunkalapID int, @dMlapatvesz smallint, @dJarmuID int

SELECT @munkalapID=MunkalapID, @mlapatvesz=Mlapatvesz, @jarmuID=JarmuID FROM inserted
SELECT @dMunkalapID=MunkalapID, @dMlapatvesz=Mlapatvesz, @dJarmuID=JarmuID FROM deleted

IF @mlapatvesz IS NULL AND @dMlapatvesz IS NULL
	RETURN

IF @mlapatvesz IS NULL
	SET @mlapatvesz = 0

IF @dMlapatvesz IS NULL
	SET @dMlapatvesz = 0

--Módosítás esetén, ha nem változott
IF @mlapatvesz = @dMlapatvesz
	RETURN

DECLARE @toolsPath varchar(200), @token varchar(4096), @command varchar(8000), @proxyAcc varchar(50), @object int, @returnValue int, @szemelyID smallint, @rendszam varchar(7), @jargyartNv varchar(30), @jartipusnv varchar(30)

--Ha van ToolsPath
SELECT @toolsPath=LTRIM(RTRIM(ToolsPath)), @proxyAcc=LTRIM(RTRIM(ProxyAcc)) FROM CEG

IF @toolsPath IS NULL
	RETURN

IF RIGHT(@toolsPath,1) <> '\'
	SET @toolsPath = @toolsPath + '\'

IF(@proxyAcc IS NULL OR @proxyAcc = '')
BEGIN
	SELECT -1 AS hiba, 'Nincs megadva a cég törzsben a Proxy Account' AS hibaszov
	RETURN
END

SELECT @rendszam=Rendszam, @jargyartNv=JargyartNv, @jartipusnv=Jartipusnv
FROM JARMU
     LEFT JOIN JARGYART ON JARGYART.JargyartID = JARMU.JargyartID
     LEFT JOIN JARTIPUS ON JARTIPUS.JartipusID = JARMU.Tipus
WHERE JARMU.JarmuID = ISNULL(@jarmuID,@dJarmuID)

DECLARE GcmUserCursor CURSOR FOR

SELECT DISTINCT GCMUSER.TOKEN, SZEMELY.SzemelyID
FROM GCMUSER
	 INNER JOIN USERS ON USERS.UserID = GCMUSER.UserID
	 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = USERS.SzemelyID
WHERE GCMUSER.ActivityNv = 'MunkalapListActivity' AND GCMUSER.StepOuTime IS NULL AND SZEMELY.SzemelyID IN(ISNULL(@mlapatvesz,0), ISNULL(@dMlapatvesz,0))

EXECUTE AS USER = @proxyAcc

OPEN GcmUserCursor

FETCH NEXT FROM GcmUserCursor INTO @token, @szemelyID
WHILE @@FETCH_STATUS = 0
BEGIN
	
	IF @szemelyID = @mlapatvesz
		SELECT @command = @toolsPath+'GCMSender\GCMSender.exe -apiKey:"AIzaSyC9PI42YCSuG0ERcQl9aDfJKdjq4xUp_FQ" -to:"'+@token+'" -data:"{ \"Muvelet\" : \"UjMunkalap\", \"Rendszam\" : \"'+@rendszam+'\"'+
			(CASE WHEN @jargyartNv IS NOT NULL THEN ', \"Gyartmany\" : \"'+@jargyartNv+'\"' ELSE '' END)+
			(CASE WHEN @jartipusnv IS NOT NULL THEN ', \"Tipus\" : \"'+@jartipusnv+'\"' ELSE '' END)+' }"'
	ELSE
		SELECT @command = @toolsPath+'GCMSender\GCMSender.exe -apiKey:"AIzaSyC9PI42YCSuG0ERcQl9aDfJKdjq4xUp_FQ" -to:"'+@token+'" -data:"{ \"Muvelet\" : \"MunkalapTorles\" }"'

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
	EXEC sp_oadestroy @object

	FETCH NEXT FROM GcmUserCursor INTO @token, @szemelyID
END

CLOSE GcmUserCursor
DEALLOCATE GcmUserCursor

REVERT