CREATE TRIGGER [dbo].[tr_ocserees_insert] ON [dbo].[OCSEREES]
FOR INSERT, DELETE
AS 
BEGIN
BEGIN TRY
	DECLARE 
	@ocsereesID int, @ocsereerID int,
	@dOcsereesID int, @dOcsereerID int, @dSzemelyID smallint,
	
	--GCM klds
	@userID smallint, @gcmMuvID int, @gcmMuvInt int

	SELECT @ocsereesID = OcsereesID, @ocsereerID = OcsereerID FROM inserted
	SELECT @dOcsereesID = OcsereesID, @dOcsereerID = OcsereerID FROM deleted

	--Ha mr zrt
	IF (SELECT COUNT(*) FROM OCSEREER WHERE OcsereerID = ISNULL(@ocsereerID, @dOcsereerID) AND (Lezarva IS NOT NULL OR ISNULL(Lezart,0) = 1)) = 1
	BEGIN
		RETURN
	END

	BEGIN TRY

		BEGIN TRAN

		IF @ocsereesID IS NOT NULL
		BEGIN
			IF @dOcsereesID IS NULL
				SET @gcmMuvInt = 24 -- j racsere fogyasztsi hely
		END
		ELSE
		BEGIN
			SET @ocsereesID = @dOcsereesID
			SET @ocsereerID = @dOcsereerID

			SET @gcmMuvInt = 25 -- j racsere fogyasztsi hely trls

			-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
			UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @ocsereesID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt IN (24))
		END

		SELECT @userID = USERS.UserID
		FROM OCSEREER
			 INNER JOIN SZCSERE ON SZCSERE.SzCsereID = OCSEREER.SzCsereID
			 INNER JOIN SZEMELY ON SZEMELY.SzemelyID = SZCSERE.Szemelyid
			 INNER JOIN USERS ON USERS.SzemelyID = SZEMELY.SzemelyID
		WHERE OCSEREER.OcsereerID = @ocsereerID AND OCSEREER.Lezarva IS NULL AND USERS.SyncInterv IS NOT NULL

		--Ha nincs felhasznlhoz ktve
		IF @userID IS NULL
		BEGIN
			COMMIT
			RETURN
		END

		SELECT @gcmMuvID = GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt

		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, OcsereerID) VALUES (@gcmMuvID, @ocsereesID, @userID, @ocsereerID)

		COMMIT

	END TRY
	BEGIN CATCH
		ROLLBACK
	END CATCH
END TRY
BEGIN CATCH
END CATCH
END