CREATE TRIGGER [dbo].[tr_onlinest_insert] ON [dbo].[ONLINEST]
FOR INSERT
AS 
BEGIN
BEGIN TRY
	DECLARE @szamlaID int, @tombID tinyint, @kozuzemi bit, @navnakFut bit

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SELECT @szamlaID = inserted.SzamlaID, @tombID = SZLATOMB.TombID, @kozuzemi = ISNULL(SZLATOMB.Kozuzemi,0), @navnakFut = ISNULL(SZLATOMB.NavnakFut,0)
	FROM inserted
		 INNER JOIN SZAMLAK ON SZAMLAK.SzamlaID = inserted.SzamlaID
		 INNER JOIN SZLATOMB ON SZLATOMB.TombID = SZAMLAK.TombID

	IF @kozuzemi = 0
		EXEC sp_online_szamla_kuld @szamlaID
	ELSE IF @navnakFut = 0
	BEGIN
		UPDATE SZLATOMB SET NavnakFut = 1, NavnakTime = GETDATE() WHERE TombID = @tombID
		EXEC sp_online_szamla_tomb_kuld @tombID
	END

END TRY
BEGIN CATCH
END CATCH
END