CREATE TRIGGER [dbo].[tr_vevoccsk_modify] ON [dbo].[VEVOCCSK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'FLEX') = 0
	RETURN

DECLARE @vevoccskID int, @cikkCsopID int, @arres numeric(5,2),

		@dVevoccskID int, @dCikkCsopID int, @dArres numeric(5,2),

		@gcmMuvInt int

SELECT @vevoccskID=VevoccskID, @cikkCsopID=CikkCsopID, @arres=Arres FROM inserted

SELECT @dVevoccskID=VevoccskID, @dCikkCsopID=CikkCsopID, @dArres=Arres FROM deleted

--j vagy mdosts
IF @vevoccskID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 105 --Vev cikkcsoport rrs letlts

	--Mdosts
	IF @dVevoccskID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkCsopID = @dCikkCsopID AND @arres = @dArres
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 106 --Vev cikkcsoport rrs trls
	SET @vevoccskID = @dVevoccskID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @vevoccskID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 105) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @vevoccskID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 105) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@vevoccskID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@vevoccskID,@webUserID2)