CREATE TRIGGER [dbo].[tr_webarak_modify2] ON [dbo].[WEBARAK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID2 smallint

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('FLEX')) = 0
	RETURN

DECLARE @webarakID int, @cikkID int, @wEgysar money, @wEgysarB money, @megszunt bit, @cikkhiercs smallint, @webre2 bit,

		@dWebarakID int, @dCikkID int, @dWEgysar money, @dWEgysarB money, @dMegszunt bit, @dCikkhiercs smallint, @dWebre2 bit

SELECT @webarakID=inserted.WebarakID, @cikkID=CIKK.CikkID, @wEgysar=inserted.WEgysar, @wEgysarB=inserted.WEgysarB,
	   @megszunt=ISNULL(CIKK.Megszunt,0), @cikkhiercs=CIKK.Cikkhiercs, @webre2=ISNULL(CIKK.Webre2,0)
FROM inserted
	 INNER JOIN CIKK ON CIKK.CikkID = inserted.CikkID

SELECT @dWebarakID=deleted.WebarakID, @dCikkID=CIKK.CikkID, @dWEgysar=deleted.WEgysar, @dWEgysarB=deleted.WEgysarB,
	   @dMegszunt=ISNULL(CIKK.Megszunt,0), @dCikkhiercs=CIKK.Cikkhiercs, @dWebre2=ISNULL(CIKK.Webre2,0)
FROM deleted
	 INNER JOIN CIKK ON CIKK.CikkID = deleted.CikkID

--j vagy mdosts
IF @webarakID IS NOT NULL
BEGIN

	--Mdosts
	IF @dWebarakID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @wEgysar = @dWEgysar AND @wEgysarB = @dWEgysarB
			RETURN

		--ha megvltozott a cikk, az eredeti cikk jboli letltse
		IF @cikkID <> @dCikkID
		BEGIN
			IF @dMegszunt = 0 AND @dCikkhiercs IS NOT NULL AND @dWebre2 = 1
				INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@dCikkID,@webUserID2)
		END
	END

	IF @megszunt = 1 OR @cikkhiercs IS NULL OR @webre2 = 0
		RETURN
END
ELSE
BEGIN
	--Nem aktulis
	IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR @dWebre2 = 0
		RETURN

	SET @cikkID = @dCikkID
END

INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID2)