
create FUNCTION [dbo].[short_address] 
(
	@unev varchar(30),@hsz varchar(3),@hszf char(3),@epulet char(1),@lepcsohaz varchar(3),@emelet varchar(2),@ajto varchar(2)
)
RETURNS varchar(50)
AS
BEGIN
	-- Declare the return variable here
	DECLARE @address    varchar(50)

	-- Add the T-SQL statements to compute the return value here
      set @hsz= isnull( @hsz,'')
      set @hszf= isnull( @hszf,'')
	  set @epulet = isnull(@epulet,'')
	  set @lepcsohaz = isnull(@lepcsohaz,'')
	  set @emelet = isnull(@emelet,'')
	  set @ajto = isnull(@ajto,'')
    set @address = rtrim(@unev)+' '+rtrim(ltrim(@hsz))
      if @hszF>''
        set @address=@address+'-'+rtrim(ltrim(@hszF))
      if @epulet=''
          set @address=@address+'.'
         else
          set @address=@address+'/'+@epulet+' '
      if @lepcsohaz>''
         set @address=@address+rtrim(ltrim(@lepcsohaz))+'.lph '
     SET @address = 
     CASE 
  WHEN rtrim(ltrim(upper(@Emelet))) = ''   THEN @address+''
	   WHEN rtrim(ltrim(upper(@Emelet))) = 'AL'   THEN @address+'Al.'
       WHEN rtrim(ltrim(upper(@Emelet)))='MF'   THEN @address+'Mf.'
       WHEN rtrim(ltrim(upper(@Emelet)))='F'   THEN @address+'Fsz.'
       WHEN rtrim(ltrim(upper(@Emelet)))='T '   THEN @address+'tt.'     
       else @address+rtrim(ltrim(@emelet))+'.em '
      END
   if @ajto>''
         set @address=@address+rtrim(ltrim(@ajto))+'.'
	RETURN @address

END


