CREATE procedure [dbo].[sp_doc_select] @docSorID int, @nullcsere bit = 1
AS
BEGIN
	DECLARE @docDirectory varchar(200), @path varchar(150), @mappankentFajlDb int = 1000, @ext varchar(5)

	--Szerver bels dokumentum knyvtra
	SELECT @docDirectory = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 190

	IF @docDirectory = ''
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a "Szerver bels dokumentum knyvtra" rendszerparamter' AS hibaszov
		RETURN
	END
	
	SELECT @ext = DocExtens FROM DOCSOR WHERE DocSorID = @docSorID

	IF RIGHT(@docDirectory, 1) <> '\'
		SET @docDirectory = @docDirectory + '\'

	SET @path = @docDirectory + DB_NAME() + '\'+ CAST((CEILING(CONVERT(decimal, @docSorID) / @mappankentFajlDb) * @mappankentFajlDb) AS varchar) + '\' + CONVERT(varchar, @docSorID) + '.' + @ext

	EXEC sp_fajl_select @path, @nullcsere
END