create procedure [dbo].[sp_docfej_insert]
 @docneve varchar(40),@DoctipID tinyint,@DocsecID tinyint,@kapcstipus tinyint,@kapcsolID int,@docutID tinyint,@creuser smallint
as
begin
declare @docidM int
begin try
begin tran
       insert into dbo.docfej (docneve,DoctipID,DocSecID,Kapcstipus,kapcsolid,docutID,creuser ) 
             values(@docneve,@DoctipID,@DocsecID,@kapcstipus,@kapcsolID,@docutID,@creuser)
        select @docidM=@@identity  

       if @kapcstipus=1 and @kapcsolID>0
         update IKTAT set DocID=@docidM where iktid=@kapcsolid   
       if @kapcstipus=2 and @kapcsolID>0
         update dbo.FOGYHELL set DocID=@docidM where FogyHEllID=@kapcsolid   
      if @kapcstipus=3 and @kapcsolID>0
         update dbo.reklamal set DocID=@docidM where reklamalID=@kapcsolid   
      if @kapcstipus=4 and @kapcsolID>0
         update dbo.vevoszrz set DocID=@docidM where szerzID=@kapcsolid   
      if @kapcstipus=5 and @kapcsolID>0
         update dbo.rendsfej set DocID=@docidM where rendsfejID=@kapcsolid   
      if @kapcstipus=6 and @kapcsolID>0
         update dbo.levelek set DocID=@docidM where levelekID=@kapcsolid   
      if @kapcstipus=7 and @kapcsolID>0
         update dbo.arajsfej set DocID=@docidM,statusz='M',valasz=getdate() where arajsfejID=@kapcsolid   
      if @kapcstipus=8 and @kapcsolID>0
         insert into  dbo.szallszs  (DocID,szerzid) values (@docidM,@kapcsolid)   
      if @kapcstipus=9 and @kapcsolID>0
         update dbo.onktamog set DocID=@docidM where onktamogid=@kapcsolid   
     if @kapcstipus=10 and @kapcsolID>0
         update dbo.berleido set DocID=@docidM where berleidoid=@kapcsolid   
     if @kapcstipus=11 and @kapcsolID>0
         update dbo.menetmag set DocID=@docidM where menetmagid=@kapcsolid   
     if @kapcstipus=12 and @kapcsolID>0
         update dbo.tetelfej set DocID=@docidM where tetelfejid=@kapcsolid   
     if @kapcstipus=13 and @kapcsolID>0
         update dbo.munkszer set DocID=@docidM where munkszerid=@kapcsolid   
     if @kapcstipus=14 and @kapcsolID>0
         update dbo.peresdoc set DocID=@docidM where peresdocid=@kapcsolid   
     if @kapcstipus=15 and @kapcsolID>0
         update dbo.igenyfej set DocID=@docidM,statusz='A' where igenyfejid=@kapcsolid   
     if @kapcstipus=16 and @kapcsolID>0
         insert into  dbo.szabalys  (DocID,szabalyzid) values (@docidM,@kapcsolid)   
     if @kapcstipus=17 and @kapcsolID>0
          update dbo.epuletdc set DocID=@docidM where epuletdcid=@kapcsolid   
     if @kapcstipus=18 and @kapcsolID>0
          update dbo.lakasdoc set DocID=@docidM where lakasdocid=@kapcsolid   
     if @kapcstipus=19 and @kapcsolID>0
          update dbo.arajvfej set DocID=@docidM where arajvfejid=@kapcsolid   
     if @kapcstipus=20 and @kapcsolID>0
          update dbo.munklap set DocID=@docidM where munkalapid=@kapcsolid   
     if @kapcstipus=21 and @kapcsolID>0
          update dbo.kikuldre set DocID=@docidM where kikuldreID=@kapcsolid   
     if @kapcstipus=22 and @kapcsolID>0
          update dbo.lbjegyzk set DocID=@docidM where lbjegyzkid=@kapcsolid   
     if @kapcstipus=24 and @kapcsolID>0
          INSERT into DOCSVALT (DocStruID,DocID,creuser) values (@kapcsolID,@docIDM,@creuser)   
    if @kapcstipus=25 and @kapcsolID>0
         update dbo.villfdoc set DocID=@docidM where villfdocid=@kapcsolid   
    if @kapcstipus=26 and @kapcsolID>0
         update dbo.pervegdc set DocID=@docidM where pervegdcid=@kapcsolid   
    if @kapcstipus=27 and @kapcsolID>0
         update dbo.folyhiba set DocID=@docidM where folyhibaID=@kapcsolid   
    if @kapcstipus=28 and @kapcsolID>0
         update dbo.terhely set DocID=@docidM where terhelyid=@kapcsolid   
    if @kapcstipus=29 and @kapcsolID>0
         update dbo.levelez set DocID=@docidM where levelezid=@kapcsolid   
   if @kapcstipus=31 and @kapcsolID>0
         update dbo.vizmuvek set DocID=@docidM where vizmuvekid=@kapcsolid   
   if @kapcstipus=32 and @kapcsolID>0
         update dbo.akcio set DocID=@docidM where akcioID=@kapcsolid   
   if @kapcstipus=33 and @kapcsolID>0
         update dbo.szallito set DocID=@docidM where szallitoid=@kapcsolid   
   if @kapcstipus=34 and @kapcsolID>0
         update dbo.vkvota set DocID=@docidM where vkvotaID=@kapcsolid   
    if @kapcstipus=35 and @kapcsolID>0
         update dbo.uzltevek set DocID=@docidM where UzlTevekID=@kapcsolid   
    if @kapcstipus=36 and @kapcsolID>0
         update dbo.fuvarjef set DocID=@docidM where fuvarjefID=@kapcsolid   
   
   commit        
 select @docidm
end try
 begin catch
   rollback tran  
   select null 
     return 
end catch

end 
