CREATE PROCEDURE [dbo].[sp_fajl_copy] @sourcePath varchar(150), @destinationPath varchar(150), @sourcePathUserName varchar(20) = NULL, @sourcePathPassword varchar(20) = NULL, @destinationPathUserName varchar(20) = NULL, @destinationPathPassword varchar(20) = NULL
AS
BEGIN

BEGIN TRY

	DECLARE @directory nvarchar(150), @mappaIndex int, @LotsOfText varchar(MAX), @result int = 1, @command nvarchar(500), @proxyAcc varchar(50) = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID),
			@sourceLogin varchar(100) = '', @destinationLogin varchar(100) = ''

	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END

	--Felhasznlnv s jelsz bellts
	IF @sourcePathUserName IS NOT NULL AND @sourcePathPassword IS NOT NULL
	BEGIN
		SET @mappaIndex = CHARINDEX('\', REVERSE(@sourcePath), 1)

		IF(@mappaIndex = 0)
		BEGIN
			SELECT -3 AS hiba, 'rvnytelen mappa' AS hibaszov
			RETURN
		END

		SET @sourceLogin = 'NET USE ' + LEFT(@sourcePath, LEN(@sourcePath) - @mappaIndex) + ' /user:' + @sourcePathUserName + ' ' + @sourcePathPassword + '>nul && '
	END

	EXECUTE AS USER = @proxyAcc

	SET @command = @sourceLogin + 'DIR "' + @sourcePath +'" /B'
	EXEC @result = xp_cmdshell @command, NO_OUTPUT

	IF @result <> 0
		SELECT -2 AS hiba, 'Nincs meg a fjl: ' + @sourcePath AS hibaszov
	ELSE
	BEGIN

		SET @mappaIndex = CHARINDEX('\', REVERSE(@destinationPath), 1)

		IF(@mappaIndex = 0)
		BEGIN
			REVERT
			SELECT -3 AS hiba, 'rvnytelen mappa' AS hibaszov
			RETURN
		END

		SET @directory = LEFT(@destinationPath, LEN(@destinationPath) - @mappaIndex)

		--Felhasznlnv s jelsz bellts
		IF @destinationPathUserName IS NOT NULL AND @destinationPathPassword IS NOT NULL
			SET @destinationLogin = 'NET USE ' + @directory + ' /user:' + @destinationPathUserName + ' ' + @destinationPathPassword + '>nul && '

		SET @command = @destinationLogin + 'DIR "' + @directory +'" /B'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT

		--ha mg nem ltezik a mappa
		IF @result <> 0
		BEGIN
			SET @mappaIndex = CHARINDEX('\', REVERSE(@directory), 1)

			IF(@mappaIndex = 0)
			BEGIN
				REVERT
				SELECT -3 AS hiba, 'rvnytelen mappa' AS hibaszov
				RETURN
			END

			SET @command = 'NET USE ' + LEFT(@directory, LEN(@directory) - @mappaIndex) + ' /user:' + @destinationPathUserName + ' ' + @destinationPathPassword + '>nul && MKDIR "' + @directory +'"'
			EXEC @result = xp_cmdshell @command, NO_OUTPUT

			--ha nem sikerlt ltrehozni
			IF @result <> 0
			BEGIN
				REVERT
				SELECT -4 AS hiba, 'Sikertelen mappa ltrehozs: ' + @directory AS hibaszov
				RETURN
			END

			--ellenrzs
			SET @command = @destinationLogin + 'DIR "' + @directory +'" /B'
			EXEC @result = xp_cmdshell @command, NO_OUTPUT

			--ha nem ltezik a mappa
			IF @result <> 0
			BEGIN
				REVERT
				SELECT -5 AS hiba, 'Nincs meg a mappa: ' + @directory AS hibaszov
				RETURN
			END
		END

		--nincs tesztelve ha a forrsnak s clnak is van jelszava
		SET @command = @sourceLogin + @destinationLogin + 'COPY "' + @sourcePath + '" "' + @destinationPath + '"'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT
		
		IF @result <> 0
		BEGIN
			REVERT
			SELECT -6 AS hiba, 'Sikertelen msols: ' + @sourcePath + ' --> ' + @destinationPath AS hibaszov
			RETURN
		END
		
		SET @command = @destinationLogin + 'DIR "' + @destinationPath +'" /B'
		EXEC @result = xp_cmdshell @command, NO_OUTPUT
		
		IF @result = 0
			SELECT 0 AS hiba, 'OK' AS hibaszov
		ELSE
			SELECT -7 AS hiba, 'Sikertelen msols (ellenrzs): ' + @destinationPath AS hibaszov
	END
	REVERT

END TRY
BEGIN CATCH
	REVERT
	SELECT -8 AS hiba, ERROR_MESSAGE() AS hibaszov
END CATCH

END