CREATE PROCEDURE [dbo].[sp_token_teszt]
AS 
BEGIN
	SET NOCOUNT ON;

	DECLARE @toolsPath varchar(200), @command varchar(8000), @object int, @returnValue int, @proxyAcc varchar(50)

	IF DB_NAME() LIKE '%teszt%'
		RETURN

	SET @proxyAcc = (SELECT TOP 1 LTRIM(RTRIM(ProxyAcc)) FROM CEG ORDER BY CegID)

	IF @proxyAcc = ''
		SET @proxyAcc = NULL

	--Ha van ToolsPath s bejelentkezsi adatok
	SELECT @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG WHERE OnSzlaTnev IS NOT NULL AND OnSzlaPass IS NOT NULL AND OnSzlaKey IS NOT NULL AND OnSzlaCky IS NOT NULL

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @command = @toolsPath+'OnlineSzamla\kri_nav.exe -operation:"tokenExchangeTest" -test:0 -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'"'

	IF @proxyAcc IS NOT NULL
	BEGIN
		EXECUTE AS USER = @proxyAcc
	END

	EXEC sp_oacreate 'WScript.Shell', @object OUT
	EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
	EXEC sp_oadestroy @object

	IF @proxyAcc IS NOT NULL
	BEGIN
		REVERT
	END
END