CREATE TRIGGER [dbo].[tr_afak_modify] ON [dbo].[AFAK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @afaID tinyint, @afaNev varchar(30), @szaz numeric(4,1),

		@dAfaID tinyint, @dAfaNev varchar(30), @dSzaz numeric(4,1),

		@gcmMuvInt int

SELECT @afaID=AfaID, @afaNev=Afanev, @szaz=Szaz FROM inserted

SELECT @dAfaID=AfaID, @dAfaNev=Afanev, @dSzaz=Szaz FROM deleted

--j vagy mdosts
IF @afaID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 42 --fa letlts

	--Mdosts
	IF @dAfaID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @afaNev = @dAfaNev AND @szaz = @dSzaz
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 43 --fa trls
	SET @afaID = @dAfaID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @afaID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 42)
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@afaID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@afaID,@webUserID2)