CREATE TRIGGER [dbo].[tr_akcio_modify] ON [dbo].[AKCIO] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('KHG','FLEX')) > 0
	RETURN

DECLARE @akcioID smallint, @akcioNev varchar(40), @tol date, @ig date, @telepID tinyint,

		@dAkcioID smallint, @dAkcioNev varchar(40), @dTol date, @dIg date, @dTelepID tinyint,

		@gcmMuvInt int

SELECT @akcioID=AkcioID, @akcioNev=AkcioNev, @tol=Tol, @ig=Ig, @telepID=TelepID FROM inserted

SELECT @dAkcioID=AkcioID, @dAkcioNev=AkcioNev, @dTol=Tol, @dIg=Ig, @dTelepID=TelepID FROM deleted

--UPDATE nem rint sort
IF @akcioID IS NULL AND @dAkcioID IS NULL
	RETURN

--Trls vagy (mdosts s telepet llt be)
IF (@akcioID IS NULL AND @dAkcioID IS NOT NULL) OR (@akcioID IS NOT NULL AND @dAkcioID IS NOT NULL AND @dTelepID IS NULL AND @telepID IS NOT NULL)
BEGIN
	--Teleppel rendelkez akci trlst nem kell kikldeni
	IF @dTelepID IS NOT NULL
		RETURN

	SET @gcmMuvInt = 57 --Akci trls
	SET @akcioID = @dAkcioID
	
	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @akcioID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 56)
END
--j vagy mdosts
ELSE
BEGIN
	SET @gcmMuvInt = 56 --Akci letlts

	--Mdosts
	IF @dAkcioID IS NOT NULL
	BEGIN
		--Teleppel rendelkez akci mdostst nem kell kikldeni
		IF @telepID IS NOT NULL
			RETURN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @akcioNev = @dAkcioNev AND @tol = @dTol AND @ig = @dIg AND @telepID = @dTelepID
			RETURN
	END
	--j
	ELSE
	BEGIN
		--Teleppel rendelkez akci rgztst nem kell kikldeni
		IF @telepID IS NOT NULL
			RETURN
	END
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@akcioID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@akcioID,@webUserID2)