CREATE TRIGGER [dbo].[tr_cikkakc_modify3] ON [dbo].[CIKKAKC] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod IN('FLEX')) = 0
	RETURN

DECLARE @cikkAkcID int, @akcioID smallint, @cikkID int, @egysarArB money, @megszunt bit, @cikkhiercs smallint, @webre bit, @webre2 bit,

		@dCikkAkcID int, @dAkcioID smallint, @dCikkID int, @dEgysarArB money, @dMegszunt bit, @dCikkhiercs smallint, @dWebre bit, @dWebre2 bit

SELECT @cikkAkcID=inserted.CikkAkcID, @akcioID=inserted.AkcioID, @cikkID=CIKK.CikkID, @egysarArB=inserted.EgysarArb,
	   @megszunt=ISNULL(CIKK.Megszunt,0), @cikkhiercs=CIKK.Cikkhiercs, @webre=ISNULL(CIKK.Webre,0), @webre2=ISNULL(CIKK.Webre2,0)
FROM inserted
	 INNER JOIN CIKK ON CIKK.CikkID = inserted.CikkID

SELECT @dCikkAkcID=deleted.CikkAkcID, @dAkcioID=deleted.AkcioID, @dCikkID=CIKK.CikkID, @dEgysarArB=deleted.EgysarArb,
	   @dMegszunt=ISNULL(CIKK.Megszunt,0), @dCikkhiercs=CIKK.Cikkhiercs, @dWebre=ISNULL(CIKK.Webre,0), @dWebre2=ISNULL(CIKK.Webre2,0)
FROM deleted
	 INNER JOIN CIKK ON CIKK.CikkID = deleted.CikkID

--j vagy mdosts
IF @cikkAkcID IS NOT NULL
BEGIN
	--Nem aktulis akci
	IF (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @akcioID AND CAST(GETDATE() AS DATE) BETWEEN Tol AND Ig AND Ervenyes IN('M','W')) = 0
		RETURN

	--Mdosts
	IF @dCikkAkcID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkID = @dCikkID AND @egysarArB = @dEgysarArB
			RETURN

		--ha megvltozott a cikk, az eredeti cikk jboli letltse
		IF @cikkID <> @dCikkID
		BEGIN
			IF @dMegszunt = 0 AND @dCikkhiercs IS NOT NULL
			BEGIN
				IF @dWebre = 1 AND @webUserID <> ''
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@dCikkID,@webUserID)

				IF @dWebre2 = 1 AND @webUserID2 <> ''
					INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@dCikkID,@webUserID2)
			END
		END
	END

	IF @megszunt = 1 OR @cikkhiercs IS NULL OR (@webre = 0 AND @webre2 = 0)
		RETURN
END
ELSE
BEGIN
	--Nem aktulis akci
	IF @dMegszunt = 1 OR @dCikkhiercs IS NULL OR (@dWebre = 0 AND @dWebre2 = 0) OR (SELECT COUNT(*) FROM AKCIO WHERE AkcioID = @dAkcioID AND CAST(GETDATE() AS DATE) BETWEEN Tol AND Ig AND Ervenyes IN('M','W')) = 0
		RETURN

	SET @cikkID = @dCikkID
	SET @webre = @dWebre
	SET @webre2 = @dWebre2
END

IF @webre = 1 AND @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID)

IF @webre2 = 1 AND @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32),@cikkID,@webUserID2)