CREATE TRIGGER [dbo].[tr_cikkhier_modify] ON [dbo].[CIKKHIER] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @cikkHierID smallint, @cikkHierNv varchar(40), @szuloID smallint, @sorrend smallint,

		@dCikkHierID smallint, @dCikkHierNv varchar(40), @dSzuloID smallint, @dSorrend smallint,

		@gcmMuvInt int

SELECT @cikkHierID=CikkHierID, @cikkHierNv=CikkHierNv, @szuloID=SzuloID, @sorrend=Sorrend FROM inserted

SELECT @dCikkHierID=CikkHierID, @dCikkHierNv=CikkHierNv, @dSzuloID=SzuloID, @dSorrend=Sorrend FROM deleted

--j vagy mdosts
IF @cikkHierID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 34 -- Cikk hierarchia letlts

	--Mdosts
	IF @dCikkHierID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @cikkHierNv = @dCikkHierNv AND ISNULL(@szuloID,0) = ISNULL(@dSzuloID,0) AND ISNULL(@sorrend,0) = ISNULL(@dSorrend,0)
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 35 -- Cikk hierarchia trls
	SET @cikkHierID = @dCikkHierID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkHierID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 34) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @cikkHierID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 34) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkHierID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@cikkHierID,@webUserID2)