CREATE TRIGGER [dbo].[tr_fuvarjes_insert] ON [dbo].[FUVARJES] 
FOR INSERT, UPDATE
AS

DECLARE @fuvarjefID int, @netto money, @tetelszam smallint, @afa money, @kedvezF numeric (5,2), @szlaRound tinyint

SELECT @fuvarjefID=fuvarjefID FROM inserted

SELECT @kedvezf=fuvarjef.Kedvezmeny, @szlaRound=DEVIZA.SzlaRound
FROM fuvarjef
	 INNER JOIN DEVIZA ON DEVIZA.DevizaID = fuvarjef.DevizaID
WHERE fuvarjef.fuvarjefid=@fuvarjefID

SELECT @netto=SUM(ISNULL(fuvarjes.Egysegar,0) * fuvarjes.Mennyi * (100-ISNULL(fuvarjes.Kedvezs,0))/100), 
       @afa=SUM(ISNULL(fuvarjes.Egysegar,0) * fuvarjes.Mennyi * (100-ISNULL(fuvarjes.Kedvezs,0))/100 * (AFAK.Szaz/100)),
       @tetelszam=COUNT(fuvarjes.fuvarjefID)
FROM fuvarjes
     LEFT JOIN AFAK ON fuvarjes.Afaid=AFAK.AfaID 
WHERE fuvarjes.fuvarjefID=@fuvarjefID

SET @kedvezF=ISNULL(@kedvezF,0)
SET @netto=ISNULL(@netto,0)
SET @afa=ISNULL(@afa,0)
SET @tetelszam=ISNULL(@tetelszam,0)

SET @netto=ROUND(@netto * (100-@kedvezF)/100, @szlaRound)
SET @afa=ROUND(@afa * (100-@kedvezF)/100, @szlaRound)

UPDATE fuvarjef SET Netto=@netto, Tetelszam=@tetelszam, Brutto=@netto + @afa WHERE fuvarjefid=@fuvarjefID