CREATE TRIGGER [dbo].[tr_gcmsync_insert] ON [dbo].[GCMSYNC]
FOR INSERT
AS 
BEGIN
BEGIN TRY

	DECLARE @gcmSyncID int, @rekordID int, @userID smallint, @gcmMuvID int, @gcmMuvInt int, @tablaID smallint, @esemeny char(1), @creUser smallint, @gcmUserID int, @token varchar(4096), @userNev varchar(30), @stepInTime smalldatetime, @stepOuTime smalldatetime, @data varchar(8000), @command varchar(8000), @proxyAcc varchar(50), @object int, @returnValue int, @leolvJel tinyint, @toolsPath varchar(200)

	SELECT @gcmSyncID = GCMSyncID, @rekordID = RekordID, @userID = UserID, @gcmMuvID = GCMMuvID FROM inserted

	SELECT TOP 1 @proxyAcc = LTRIM(RTRIM(ProxyAcc)), @toolsPath = LTRIM(RTRIM(ToolsPath)) FROM CEG ORDER BY CegID
		
	IF(@proxyAcc IS NULL OR @proxyAcc = '')
	BEGIN
		SELECT -1 AS hiba, 'Nincs megadva a cg trzsben a Proxy Account' AS hibaszov
		RETURN
	END

	IF @toolsPath IS NULL
		RETURN

	IF RIGHT(@toolsPath,1) <> '\'
		SET @toolsPath = @toolsPath + '\'

	SELECT @gcmMuvInt = GCMmuvInt FROM GCMMUV WHERE GCMMuvID = @gcmMuvID
 
	IF @gcmMuvInt <= 31
	BEGIN
		--j ralls
		IF @gcmMuvInt = 1
			SELECT @creUser = CreUser, @leolvJel = LeolvJel FROM OLVAS WHERE OlvasID = @rekordID
	
		--ralls mdosts
		IF @gcmMuvInt = 2
		BEGIN
			SET @tablaID = 136; --OLVAS
			SET @esemeny = 'J'
		END

		--ralls trls
		IF @gcmMuvInt = 3
		BEGIN
			SET @tablaID = 136; --OLVAS
			SET @esemeny = 'T'
		END

		--Fogyaszthely mdosts 4
		IF @gcmMuvInt = 4
		BEGIN
			SET @tablaID = 53; --FOHELY
			SET @esemeny = 'J'
		END
	
		--Ellenrzs mdosts
		IF @gcmMuvInt = 6
		BEGIN
			SET @tablaID = 149; --FOGYHELL
			SET @esemeny = 'J'
		END
	
		--racsere mdosts
		IF @gcmMuvInt = 9
		BEGIN
			SET @tablaID = 499; --OCSEREER
			SET @esemeny = 'J'
		END

		--j vev elrhetsg
		IF @gcmMuvInt = 11
			SELECT @creUser = CreUser FROM VEVOKPCS WHERE VevokpcsID = @rekordID
	
		--Vev elrhetsg mdosts
		IF @gcmMuvInt = 12
		BEGIN
			SET @tablaID = 78; --VEVOKPCS
			SET @esemeny = 'J'
		END

		--Vev elrhetsg trls
		IF @gcmMuvInt = 13
		BEGIN
			SET @tablaID = 78; --VEVOKPCS
			SET @esemeny = 'T'
		END

		--j villamos ralls
		IF @gcmMuvInt = 21
			SELECT @creUser = CreUser FROM VILLORA WHERE VillOraID = @rekordID
	
		--Villamos ralls mdosts
		IF @gcmMuvInt = 22
		BEGIN
			SET @tablaID = 209; --VILLORA
			SET @esemeny = 'J'
		END

		--Villamos ralls trls
		IF @gcmMuvInt = 23
		BEGIN
			SET @tablaID = 209; --VILLORA
			SET @esemeny = 'T'
		END

		--j vztermels ralls
		IF @gcmMuvInt = 29
			SELECT @creUser = CreUser FROM VILLORA WHERE VillOraID = @rekordID
	
		--Vztermels ralls mdosts
		IF @gcmMuvInt = 30
		BEGIN
			SET @tablaID = 583; --OLVAST
			SET @esemeny = 'J'
		END

		--Vztermels ralls trls
		IF @gcmMuvInt = 31
		BEGIN
			SET @tablaID = 583; --OLVAST
			SET @esemeny = 'T'
		END

		IF @tablaID IS NOT NULL
			SELECT TOP 1 @creUser = UserID FROM HISTORY WHERE Tablaid = @tablaID AND RekordID = @rekordID AND Esemeny = @esemeny ORDER BY histID DESC

		IF CURSOR_STATUS('global','GcmUserCursor')>=-1
		BEGIN
			CLOSE GcmUserCursor
			DEALLOCATE GcmUserCursor
		END

		DECLARE GcmUserCursor CURSOR FOR

		SELECT GCMUSER.GCMUserID, GCMUSER.TOKEN, USERS.UserID, LTRIM(RTRIM(USERS.UserNev)) AS 'UserNev', GCMUSER.StepInTime, GCMUSER.StepOuTime
		FROM GCMUSER
			 INNER JOIN USERS ON USERS.UserID = GCMUSER.UserID
		WHERE USERS.UserID = @userID

		OPEN GcmUserCursor

		EXECUTE AS USER = @proxyAcc

		FETCH NEXT FROM GcmUserCursor INTO @gcmUserID, @token, @userID, @userNev, @stepInTime, @stepOuTime
		WHILE @@FETCH_STATUS = 0
		BEGIN
			--Rgzt ne kapja meg jbl, kivtel ha racsere volt, mert csak akkor fut r ide, ha van nyitott leolvas csomag vagy ellenrzse
			IF @creUser IS NOT NULL AND @creUser = @userID AND (@gcmMuvInt <> 1 OR @leolvJel NOT IN(1,2))
				INSERT INTO GCMSYNCU (GCMSyncID, GCMUserID) VALUES(@gcmSyncID, @gcmUserID)
			ELSE
			BEGIN
				--Ha be van jelentkezve, azonnali klds
				IF @stepInTime IS NOT NULL AND @stepOuTime IS NULL
				BEGIN
					SELECT @command = @toolsPath+'GCMSender\GCMSender.exe -apiKey:"AIzaSyC9PI42YCSuG0ERcQl9aDfJKdjq4xUp_FQ" -to:"'+@token+'" -data:"{ \"Muvelet\" : \"SyncLeker\", \"AccountName\" : \"'+@userNev+'\" }"'

					EXEC sp_oacreate 'WScript.Shell', @object OUT
					EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
					EXEC sp_oadestroy @object

				END
			END
			FETCH NEXT FROM GcmUserCursor INTO @gcmUserID, @token, @userID, @userNev, @stepInTime, @stepOuTime
		END

		REVERT

		CLOSE GcmUserCursor
		DEALLOCATE GcmUserCursor

	END
	ELSE
	BEGIN
		--WebShop frisst URL
		DECLARE @webUrl varchar(100), @webUserID smallint, @webUserID2 smallint, @pos int

		SELECT TOP 1 @webUrl = LTRIM(RTRIM(ISNULL(WebShop,''))) FROM CEG ORDER BY CegID

		IF @webUrl <> ''
		BEGIN
			--WEB user azonost
			SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

			--WEB user azonost 2
			SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

			SET @pos  = CHARINDEX(',', @webUrl)

			--Ha els webUser vagy msodik webUser s van msodik URL
			IF (@webUserID <> '' AND @webUserID = @userID) OR (@webUserID2 <> '' AND @webUserID2 = @userID AND @pos > 0)
			BEGIN
				--Ha 2 URL van
				IF @pos > 0
				BEGIN
					IF @webUserID <> '' AND @webUserID = @userID
						SET @webUrl = LTRIM(RTRIM(SUBSTRING(@webUrl, 1, @pos-1)))
					ELSE
						SET @webUrl = LTRIM(RTRIM(SUBSTRING(@webUrl, @pos+1, LEN(@webUrl)-@pos)))
				END

				IF @webUrl <> ''
				BEGIN
					EXECUTE AS USER = @proxyAcc
					EXEC sp_call_url @webUrl
					REVERT
				END
			END
		END

		IF DB_NAME() LIKE '%teszt%'
			RETURN

		--Digitlis cmke
		SELECT @userID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 228

		IF @userID <> ''
		BEGIN
			EXECUTE AS USER = @proxyAcc

			SELECT @command = @toolsPath+'DigitalisCimke\kri_dc.exe -operation:"sync" -server:"'+@@SERVERNAME+'" -database:"'+DB_NAME()+'"'

			EXEC sp_oacreate 'WScript.Shell', @object OUT
			EXEC sp_oamethod @object, 'run', @returnValue OUT, @command
			EXEC sp_oadestroy @object

			REVERT
		END

	END
END TRY
BEGIN CATCH
END CATCH
END