CREATE TRIGGER [dbo].[tr_levelek_insert] ON [dbo].[LEVELEK] 
FOR INSERT 
AS
DECLARE @levCsopID int, @levelekID int, @sorszam int, @betujel char(3), @irany char(1), @kelt date, @hivatkozas int, @ugylet int, @tombjel varchar(10)

SELECT @levCsopID=LevCsopID, @levelekID=LevelekID, @irany=Irany, @kelt=Kelt, @hivatkozas=Hivatkozas, @ugylet=ISNULL(Ugylet,0) FROM inserted

SELECT @betujel=Betujel FROM LEVCSOP WHERE LevCsopID=@levCsopID

IF @ugylet=0
BEGIN
	SELECT @ugylet=ISNULL(MAX(Ugylet),0) FROM LEVELEK
	SET @ugylet=@ugylet+1
END

SET @tombjel=@irany+RTRIM(@betujel)+'/'+STR(YEAR(@kelt),4)+'/'

SELECT @sorszam=ISNULL(MAX(CONVERT(int,RIGHT(LevIktszam,CHARINDEX('/',REVERSE(LevIktszam))-1))), 0) + 1 FROM LEVELEK WHERE LEFT(LevIktszam,LEN(RTRIM(@tombjel)))=RTRIM(@tombjel)

UPDATE LEVELEK SET LevIktszam=@tombjel+RIGHT('00000'+LTRIM(STR(@sorszam)),7-LEN(RTRIM(@betujel))), Ugylet=@ugylet WHERE LevelekID=@levelekID

IF ISNULL(@hivatkozas,0)>0
	UPDATE LEVELEK SET Kovetkezo=@levelekID, Ugylet=@ugylet WHERE LevelekID=@hivatkozas AND ISNULL(Kovetkezo,0)=0