CREATE TRIGGER [dbo].[tr_varosok_modify] ON [dbo].[VAROSOK] FOR INSERT,UPDATE,DELETE
AS
DECLARE @webUserID smallint, @webUserID2 smallint

--WEB user azonost
SELECT @webUserID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 225

--WEB user azonost 2
SELECT @webUserID2 = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 243

IF @webUserID = '' AND @webUserID2 = ''
	RETURN

IF (SELECT COUNT(*) FROM CEG WHERE Cegkod = 'KHG') > 0
	RETURN

DECLARE @varosID smallint, @varosIrsz varchar(10), @varosNev varchar(40),

		@dVarosID smallint, @dVarosIrsz varchar(10), @dVarosNev varchar(40),

		@gcmMuvInt int

SELECT @varosID=VarosID, @varosIrsz=VarosIrsz, @varosNev=VarosNev FROM inserted

SELECT @dVarosID=VarosID, @dVarosIrsz=VarosIrsz, @dVarosNev=VarosNev  FROM deleted

--j vagy mdosts
IF @varosID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 70 --Vros letlts

	--Mdosts
	IF @dVarosID IS NOT NULL
	BEGIN

		--ha nem vltozott az tadott rtkek valamelyike
		IF @varosIrsz = @dVarosIrsz AND @varosNev = @dVarosNev
			RETURN

	END
END
ELSE
BEGIN
	SET @gcmMuvInt = 71 --Vros trls
	SET @varosID = @dVarosID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	IF @webUserID <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @varosID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 70) AND UserID = @webUserID

	IF @webUserID2 <> ''
		UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @varosID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 70) AND UserID = @webUserID2
END

IF @webUserID <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@varosID,@webUserID)

IF @webUserID2 <> ''
	INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@varosID,@webUserID2)