CREATE TRIGGER [dbo].[tr_vonalkod_modify] ON [dbo].[VONALKOD] FOR INSERT,UPDATE,DELETE
AS

DECLARE @userID smallint

--Digitlis cmke user azonost
SELECT @userID = LTRIM(RTRIM(ISNULL(Ertek, ''))) FROM SETUP WHERE SetupID = 228

IF @userID = ''
	RETURN

DECLARE @vonalkodID int, @vonalkod varchar(14),

		@dVonalkodID int, @dVonalkod varchar(14),

		@gcmMuvInt int

SELECT @vonalkodID=VonalkodID, @vonalkod=vonalkod FROM inserted

SELECT @dVonalkodID=VonalkodID, @dVonalkod=vonalkod FROM deleted

--Trls
IF @vonalkodID IS NULL AND @dVonalkodID IS NOT NULL
BEGIN
	SET @gcmMuvInt = 33 -- Cikk trls
	SET @vonalkodID = @dVonalkodID

	-- Trls esetn zrtt tenni a korbbi rekordhoz tartoz esemnyeket
	UPDATE GCMSYNC SET Zart = 1 WHERE RekordID = @vonalkodID AND GCMMuvID IN(SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 32)
END
--j vagy mdosts
ELSE
BEGIN
	SET @gcmMuvInt = 32 --Cikk letlts

	--Mdosts
	IF @dVonalkodID IS NOT NULL
	BEGIN

		--Ha nem vltozott az tadott rtkek valamelyike
		IF @vonalkod = @dVonalkod
			RETURN

		INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, Vonalkod) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = 33),@vonalkodID,@userID,@dVonalkod)
		
		SET @dVonalkod = NULL --Frisstshez nem kell a trlt vonalkd
	END
END

INSERT INTO GCMSYNC (GCMMuvID, RekordID, UserID, Vonalkod) VALUES ((SELECT GCMMuvID FROM GCMMUV WHERE GCMMuvInt = @gcmMuvInt),@vonalkodID,@userID,@dVonalkod)