create TRIGGER tr_Zonavalt on dbo.zonavalt
   AFTER  INSERT,DELETE,UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for trigger here
declare @zona int,@izona int , @vizm3 int,@kelt date,@kuttermid int,@hom int,@cikl int,@dzona int, @dvizm3  int,@dkelt date,
   @zonamozgid int,@dzonamozgid int,@zonaforgid int,@celzona int,@dcelzona int,@iranypar int,@diranypar int,@szuloid int,@szuloid2 int,@dzonavaltid int,@viz int

select @izona=zonaID,@kelt=kelt,@vizm3=vizm3,@zonamozgid=i.zonamozgid,@celzona=celzona,@iranypar=iranypar from inserted i left join zonamozg on i.zonamozgid=zonamozg.zonamozgid
select @dzona=zonaID,@dkelt=kelt,@dvizm3=vizm3,@dzonamozgid=d.zonamozgid,@dcelzona=celzona,@diranypar=iranypar,@dzonavaltid=zonavaltid from deleted d left join zonamozg on d.zonamozgid=zonamozg.zonamozgid 
set @zona=@izona
set @viz=@vizm3
set @cikl=2
set @szuloid=@@IDENTITY
if isnull(@zona,0)=0  
  set @cikl=1
   
  
-- --  
while @cikl>0 
  begin
  if @cikl=1
    begin
      if isnull(@dzona,0)=0  BREAK
      select @kelt=@dkelt,@viz=@dvizm3,@zona=@dzona,@zonamozgid=@dzonamozgid,@celzona=@dcelzona,@iranypar=@diranypar
    end
  
   set @cikl=@cikl-1
   

  select @vizm3=sum(vizm3) from zonavalt where zonaID=@zona and month(kelt)=month(@kelt) and year(kelt)=year(@kelt) and zonamozgID=@zonamozgid 
  set @vizm3=isnull(@vizm3,0)
  select @zonaforgid=zonaforgid from zonaforg where zonamozgID=@zonamozgid and zonaid=@zona and ev=year(@kelt)
  if isnull(@zonaforgid,0)=0
   insert into zonaforg (zonaID,ev,zonamozgid) values
   (@zona,year(@kelt),@zonamozgid)
   
   
  set @hom= month(@kelt) 
 if @hom=1  update zonaforg set ho1=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=2  update zonaforg set ho2=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=3  update zonaforg set ho3=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=4  update zonaforg set ho4=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=5  update zonaforg set ho5=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=6  update zonaforg set ho6=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=7  update zonaforg set ho7=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=8  update zonaforg set ho8=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=9  update zonaforg set ho9=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=10  update zonaforg set ho10=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=11  update zonaforg set ho11=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)
 if @hom=12  update zonaforg set ho12=@vizm3 where zonamozgID=@zonamozgid and zonaID=@zona and ev=year(@kelt)

if isnull(@celzona,0)>0 and isnull(@iranypar,0)>0
   begin
    if @cikl=1
    begin
       if isnull(@dzona,0)=0 
     begin
       insert into zonavalt (zonaID,kelt,zonamozgid,vizm3,celzona,szuloid ) values (@celzona,@kelt,@iranypar,@vizm3,@zona,@szuloid)
       set @szuloid2=@@IDENTITY
       update zonavalt set szuloid=@szuloid2 where zonavaltid=@szuloid
     end
       if isnull(@dzona,0)>0 and isnull(@izona,0)>0
     update zonavalt set vizm3=@viz,kelt=@kelt where szuloid=@dzonavaltid  --zona=@celzona and  month(kelt)=month(@kelt) and year(kelt)=year(@kelt) and zonamozgid=@iranypar 
    end 
  if ISNULL(@dzona,0)>0 and isnull(@izona,0)=0
      delete from zonavalt where  szuloid=@dzonavaltid --ZONA=@celzona and zonamozgid=@iranypar and  month(kelt)=month(@kelt) and year(kelt)=year(@kelt)
      
  select @vizm3=sum(vizm3) from zonavalt where zonaID=@celzona and month(kelt)=month(@kelt) and year(kelt)=year(@kelt) and zonamozgID=@iranypar 
  set @vizm3=isnull(@vizm3,0)
  select @zonaforgid=zonaforgid from zonaforg where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
  if isnull(@zonaforgid,0)=0
   insert into zonaforg (zonaID,ev,zonamozgid) values (@celzona,year(@kelt),@iranypar)
   
   
  set @hom= month(@kelt) 
 if @hom=1  update zonaforg set ho1=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=2  update zonaforg set ho2=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=3  update zonaforg set ho3=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=4  update zonaforg set ho4=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=5  update zonaforg set ho5=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=6  update zonaforg set ho6=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=7  update zonaforg set ho7=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=8  update zonaforg set ho8=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=9  update zonaforg set ho9=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=10  update zonaforg set ho10=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=11  update zonaforg set ho11=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
 if @hom=12  update zonaforg set ho12=@vizm3 where zonamozgID=@iranypar and zonaID=@celzona and ev=year(@kelt)
                
   end
 
 
end

 



END